
package org.netbeans.modules.asm.x86.syntax.att.fake;

import java.util.ArrayList;
import java.util.List;
import org.netbeans.modules.asm.model.lang.InstructionInstance;
import org.netbeans.modules.asm.model.lang.OperandInstance;
import org.netbeans.modules.asm.model.lang.instruction.Instruction;
import org.netbeans.modules.asm.model.lang.operand.Operand;

public class X86InstructionInstance implements InstructionInstance {
    
    private Instruction instr; 
    private List<Operand> opl;
    private int start, end;
    
    public X86InstructionInstance(Instruction instr, Operand op, 
                                  int start, int end) {       
        this.instr = instr;                
        this.start = start;
        this.end = end;
        
        opl = new ArrayList<Operand>(1);
        opl.add(op);
        
    }

    public Instruction getInstruction() {
        return instr;
    }

    public List<Operand> getOperands() {
        return opl;        
    }

    public int getStartOffset() {
        return start;
    }

    public int getEndOffset() {
        return end;
    }
    
}
