// ==UserScript==
// @name           Bugzilla Attachments
// @namespace      http://wiki.netbeans.org/BrowserTools
// @description    Displays Bugzilla attachments inline.
// @include        */show_bug.cgi?id=*
// ==/UserScript==
//GM_log("Searching...");
trs = document.evaluate('//tr[contains(td[1]/a/@href, "attachment.cgi")]', document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
for (var i = 0; i < trs.snapshotLength; i++) {
    tr = trs.snapshotItem(i);
    url = document.evaluate('td[1]/a/@href', tr, null, XPathResult.STRING_TYPE, null).stringValue;
    //GM_log("Found: " + url);
    if (document.evaluate('td[1]//span[@class="bz_obsolete"]', tr, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null).snapshotLength > 0) {
        //GM_log("Obsolete");
        continue;
    }
    description = document.evaluate('td[1]/span[@class="bz_attach_extra_info"]', tr, null, XPathResult.STRING_TYPE, null).stringValue;
    body = null;
    //GM_log("Description: " + description);
    if (description.match(new RegExp(' image/[a-z]+\\)'))) {
        body = '<img src="' + url + '">';
    } else if (description.match(new RegExp(' (text/.+|patch)\\)'))) {
        body = '<iframe src="' + url + '" width="100%" height="300">';
    }
    //GM_log("Body: " + body);
    if (body !== null) {
        { // Workaround for https://bugzilla.mozilla.org/show_bug.cgi?id=537083
            var head = document.getElementsByTagName('head')[0];
            var style = document.createElement('style');
            style.type = 'text/css';
            style.innerHTML = '#attachment_table {width: 100%}';
            head.appendChild(style);
        }
        newtr = document.createElement('tr');
        tr.parentNode.insertBefore(newtr, tr.nextSibling);
        newtd = document.createElement('td');
        newtd.innerHTML = body;
        newtd.setAttribute('colspan', '2');
        newtr.insertBefore(newtd, null);
    }
}
