
package org.netbeans.jsstubsgenerator.dom;

import java.io.IOException;
import java.util.List;
import java.util.Map;
import org.netbeans.jsstubsgenerator.stub.GeneratorUtils;
import org.netbeans.jsstubsgenerator.stub.Origin;
import org.netbeans.jsstubsgenerator.stub.StubObject;
import org.netbeans.jsstubsgenerator.stub.Type;

/**
 *
 * @author Martin Fousek <marfous@netbeans.org>
 */
public class AbstractWorkerGenerator {

    private static final String OBJECT_NAME = "AbstractWorker";

    public static void generate(Map<String, StubObject> allStubs) throws IOException {
        // general definition
        StubObject abstractWorker = new StubObject(Origin.DOM, OBJECT_NAME, StubObject.GLOBAL);
        abstractWorker.setPrune(true);
        abstractWorker.setType(Type.OBJECT);
        abstractWorker.setSummary("The AbstractWorker interface abstracts properties and methods common to all kind of workers, being Worker or SharedWorker.");

        // attributes definition
        String[][] attributes = new String[][]{
            {"onerror", "undefined", "Is an EventListener that is called whenever an ErrorEvent of type error bubbles through the worker."},
        };
        List<StubObject> generatedInstanceProperties = GeneratorUtils.generateProperties(Origin.DOM, attributes, OBJECT_NAME, false);
        for (StubObject instanceProperty : generatedInstanceProperties) {
            abstractWorker.putAttribute(instanceProperty);
        }

        allStubs.put(OBJECT_NAME, abstractWorker);
    }

}
