/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.netbeans.jsstubsgenerator.print;

import java.util.logging.Logger;
import org.jsoup.Jsoup;
import org.netbeans.jsstubsgenerator.core.ecma.EcmaCoreGenerator;
import org.netbeans.jsstubsgenerator.stub.StubObject;

/**
 *
 * @author Martin Fousek <marfous@netbeans.org>
 */
public class Utils {
     private static final Logger LOGGER = Logger.getLogger(Utils.class.getName());
    private Utils() {
    }

    public static void fulfilArguments(JsDocBuilder jsBuilder, StubObject stubObject) {
        String originalSyntax = Jsoup.parse(stubObject.getSyntax().trim()).text().trim();
        if (originalSyntax.indexOf(")") != -1) {
            String firstLineSyntax = originalSyntax.substring(0, originalSyntax.indexOf(")"));
            if (firstLineSyntax.indexOf(stubObject.getName()) == -1) {
                LOGGER.warning("Problem to parse syntax: " + originalSyntax);
                return;
            }
            // get string where the name starts
            String realSyntax = firstLineSyntax.substring(firstLineSyntax.indexOf(stubObject.getName()));

            // remove the beggining of the syntax
            String arguments = realSyntax.substring(realSyntax.indexOf("(") + 1);

            // remove everything behind ", ["
            String minSyntax = (arguments.indexOf(", [") > -1) ? arguments.substring(0, arguments.indexOf(", [")) : arguments;

            // remove everything behind "["
            minSyntax = (minSyntax.indexOf("[") > -1) ? minSyntax.substring(0, minSyntax.indexOf("[")) : minSyntax;

            // remove everything behind "..."
            minSyntax = (minSyntax.indexOf(", ...") > -1) ? minSyntax.substring(0, minSyntax.indexOf(", ...")) : minSyntax;

            // remove quots
            minSyntax = minSyntax.matches("\".*\"") ? minSyntax.replace("\"", "") : minSyntax;

            // remove quots
            minSyntax = minSyntax.matches("\".*\"") ? minSyntax.replace("\"", "") : minSyntax;

            String[] split = minSyntax.split("[,]");
            String delim = "";
            for (String string : split) {
                if (string.contains("-")) {
                    string = string.replace("-", "");
                }
                String name = string.trim().contains("|") ? string.split("[|]")[0] : string.trim();
                jsBuilder.append(delim, false).append(name, false);
                delim = ", ";
            }
        }
    }
}
