<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@ page import="java.util.Map" %>
<%@ taglib uri="/WEB-INF/statistics.tld" prefix="ui"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%> 

<c:set var="path" value='/ <a href="../index.jsp">Analytics</a> / Graph / Indexing '/>
<%@include file="/WEB-INF/jspf/header.jspf" %>
<ui:useStatistic name="Parsing"/>

    <div class="f-page-cell bg-sky" >
        <h2>How much time is spend indexing?</h2>
        
        <p>
            People often complain that the IDE is scanning too much. 
            But does it? Maybe the scanning is not that frequent. 
            To analyse this and also capture future trends we have 
            this statistic comparing how much time has been spent in
            scanning and how much time the IDE run without scanning at all.
        </p>
        <%@include file="restrictQuery.jspf" %>
    </div>

    <% 
        Map invLast = (Map)pageContext.getAttribute("lastParsing");
        Map invUser = (Map)pageContext.getAttribute("userParsing");
        Map invAll = (Map)pageContext.getAttribute("globalParsing");
    %>

    <p class="b-bottom-dashed b-top f-page-cell">
        <% if (invLast != null && !invLast.isEmpty()) {%>
        Your IDE has spend <% out.println(invLast.get("Indexing")); %> seconds
        indexing compared to <% out.println(invLast.get("Ready")); %> seconds
        having the IDE ready to answer your questions during most recent work:
        </p>
        <ui:pie collection="lastParsing" category="key" value="value"/>
        <p>
    <% }%>
    </p>

    <% if (invUser != null && !invUser.isEmpty()) { %>
    <p>
        Your IDE has spent <% out.println(invUser.get("Indexing")); %> seconds
        indexing since you started to use it compared to 
        <% out.println(invUser.get("Ready")); %> seconds being ready.
        What is your score compared to other users?
    </p>
        <ui:pie collection="userParsing" category="key" value="value"/>
    
    <% } %>
    
    <% if (invAll != null && !invAll.isEmpty()) { %>
    <p class="b-bottom-dashed b-top f-page-cell">
        Overall ratio between scanning and indexing and being ready from all
        the users of the NetBeans IDE:
    </p>
        <ui:pie collection="globalParsing" category="key" value="value" />
    <p>
        The total time spend in scanning is <% out.println(invAll.get("Indexing")); %>
        seconds, while for <% out.println(invAll.get("Ready")); %> seconds, the IDE was 
        in ready to use state. It appears the IDE was idle and 
        untouched for <% out.println(invAll.get("Idle")); %> seconds.
    </p>
    <% } %>
<%@include file="/WEB-INF/jspf/footer.jspf" %> 
