<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@ page import="java.util.Map" %>
<%@ page import="java.util.Set" %>
<%@ page import="org.netbeans.server.uihandler.statistics.Vaadin" %>
<%@ taglib uri="/WEB-INF/statistics.tld" prefix="ui" %>
<%@taglib prefix="f" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %> 

<c:set var="path" value='/ <a href="../index.jsp">Analytics</a> / Graph / Vaadin'/>
<%@include file="/WEB-INF/jspf/header.jspf" %>

<ui:useStatistic name="Vaadin"/>

    <div class="f-page-cell bg-sky" >
        <h2>Vaadin plugin usage</h2>
        
        <p>
            This statistics page allows to see which plugin features are more 
            popular and how many plugin users per feature/overall.
            Below is a graph for this information. The first line indicates the 
            overall "unique" plugin users. The second section contains information 
            about AddOn feature usage (AddOn can be added either via code 
            completion directly from Java editor or via AddOn browser available 
            as a project action). Other sections contain tables for project wizard,
            widget wizard, project actions and editor fixes available via hints.
        </p>
        
        <h3>Restrict the Query!</h3>
        <form method="get" action="<%= org.netbeans.web.Utils.getContextURL(request)%>/vaadin.jsp" >
            <table width="100%">
                <tr>
                    <td>Statistics category:</td>
                    <td>Usage amounts (unique or overall):</td>
                    <td>NetBeans version:</td>
                    <td></td>
                </tr>
                <tr>     
                    <td>
                    <select name="category">
                        <c:forEach items="${categories}" var="categoryItem">
                            <c:choose>
                                <c:when test="${f:contains(categoryItem, category)}">
                                    <option selected="selected">${categoryItem}</option>
                                </c:when>
                                <c:otherwise>
                                    <option>${categoryItem}</option>
                                </c:otherwise>
                            </c:choose>
                        </c:forEach>
                    </select>
                    </td>
                    <td>
                    <select name="usage">
                        <c:forEach items="${usages}" var="useItem">
                            <c:choose>
                                <c:when test="${f:startsWith(useItem, usage)}">
                                    <option selected="selected">${useItem}</option>
                                </c:when>
                                <c:otherwise>
                                    <option>${useItem}</option>
                                </c:otherwise>
                            </c:choose>
                        </c:forEach>
                    </select>
                    </td>
                    <td><%@include file="../WEB-INF/jspf/nbVersionComboBox.jspf" %> </td>
                    <td><input type="submit"/></td>
                </tr>
            </table>
        </form>
    </div>
                    
        <table cellpadding="5" width="100%">
            <tr><td class="tblheader" width="20%">Total plugin users:</td>
        <td class="tbltd1"><% Vaadin.VaadinData data = (Vaadin.VaadinData)pageContext.getAttribute("globalVaadin"); 
            out.print(data.getIds().size()); %>
        </td></tr>
        </table>
        
        
        <%  
        Object cat = pageContext.getAttribute(Vaadin.CATEGORY);
        Object use = pageContext.getAttribute(Vaadin.USAGE);
        
        boolean showUnique = Vaadin.UsageFilter.ALL.name().equals(use) || 
                Vaadin.UsageFilter.UNIQUE.name().equals(use);
        boolean showOverall = Vaadin.UsageFilter.ALL.name().equals(use) || 
                Vaadin.UsageFilter.OVERALL.name().equals(use);
        
        if ( Vaadin.Category.ALL.name().equals(cat) || Vaadin.Category.ADD_ONS.name().equals(cat)) {
            Vaadin.AddonsStat addons = (Vaadin.AddonsStat)pageContext.getAttribute(Vaadin.ADDONS); %>
        <table cellpadding="5" width="100%" >
        <thead class="tblheader">
            <th width="20%"></th>
            <% if  ( showUnique){ %>
            <th>Unique users</th>
            <% } 
              if  ( showOverall){ %>
            <th>Overall</th>
            <% } %>
        </thead>  
            <tr>
                <td class="tblheader">AddOns feature Usage</td>
                <% if  ( showUnique){ %>
                <td class="tbltd1"><% out.println(addons.getUniqueUsers()); %></td>
                <% } 
                if  ( showOverall){ %>
                <td class="tbltd1"><% out.println(addons.getOverallUsage()); %></td>
                 <% } %>
            </tr>
        </table>
            
        <%  
            }
        if ( Vaadin.Category.ALL.name().equals(cat) || Vaadin.Category.PROJECTS.name().equals(cat)) {    
            Vaadin.ProjectsStat projects = (Vaadin.ProjectsStat)pageContext.getAttribute(Vaadin.PROJECT_WIZARDS); 
        if  ( showUnique){ 
            pageContext.setAttribute("vaadinProjectsUniqueUsers", projects.getDisplayPresentation(projects.getUniqueUsers()));
        }
        if (showOverall){
            pageContext.setAttribute("vaadinProjectsOverall", projects.getDisplayPresentation(projects.getOverallUsage()));
        }
        %>
            <div align="center">
            <% if  ( showUnique){ %>
            <ui:pie collection="vaadinProjectsUniqueUsers" category="key" value="value"      
                title="Project type wizard (unique users)" resolution="600x200" />
            <% } 
                if  ( showOverall){ %>
            <ui:pie collection="vaadinProjectsOverall" category="key" value="value" 
                title="Project type wizard (overall)" resolution="600x200" />
            <% } %>
            </div>
        <table cellpadding="5" width="100%" >
        <thead class="tblheader">
            <th width="20%">Project type wizard</th>
            <% if  ( showUnique){ %>
            <th>Unique users</th>
            <% } 
                if  ( showOverall){ %>
            <th>Overall</th>
            <% } %>
        </thead>
        
        
        <%    for(String key : projects.getOverallUsage().keySet()) { %>
            <tr>
                <td class="tbltd1"><% out.println(projects.getDisplayName(key)); %></td>
                <% if  ( showUnique){ %>
                <td class="tbltd1"><% out.println(projects.getUniqueUsers().get(key)); %></td>
                <% } 
                if  ( showOverall){ %>
                <td class="tbltd1"><% out.println(projects.getOverallUsage().get(key)); %></td>
                <% } %>
            </tr>
         <% } %>
        
        </table>
         
        <%  
            }
        if ( Vaadin.Category.ALL.name().equals(cat) || Vaadin.Category.WIDGETS.name().equals(cat)) {       
            Vaadin.ComponentWizardStat widgets = (Vaadin.ComponentWizardStat)pageContext.getAttribute(Vaadin.COMPONENT_WIZARDS);  
            if  ( showUnique){ 
            pageContext.setAttribute("vaadinWidgetsUniqueUsers", widgets.getDisplayPresentation(widgets.getUniqueUsers()));
            }
            if (showOverall){
            pageContext.setAttribute("vaadinWidgetsOverall", widgets.getDisplayPresentation(widgets.getOverallUsage()));
            }
        %>
            <div align="center">
            <% if  ( showUnique){ %>
            <ui:pie collection="vaadinWidgetsUniqueUsers" category="key" value="value" 
                title="Vaadin Component wizard (unique users)" resolution="600x200" />
            <% } 
                if  ( showOverall){ %>
            <ui:pie collection="vaadinWidgetsOverall" category="key" value="value" 
                title="Vaadin Component wizard (overall)" resolution="600x200" />
            <% } %>
            </div>
        <table cellpadding="5" width="100%" >
        <thead class="tblheader">
            <th width="20%">Widgets type wizard</th>
            <% if  ( showUnique){ %>
            <th>Unique users</th>
            <% } 
                if  ( showOverall){ %>
            <th>Overall</th>
            <% } %>
        </thead>
        <%  for(String key : widgets.getOverallUsage().keySet()) { %>
            <tr>
                <td class="tbltd1"><% out.println(widgets.getDisplayName(key)); %></td>
                <% if  ( showUnique){ %>
                <td class="tbltd1"><% out.println(widgets.getUniqueUsers().get(key)); %></td>
                <% } 
                if  ( showOverall){ %>
                <td class="tbltd1"><% out.println(widgets.getOverallUsage().get(key)); %></td>
                <% } %>
            </tr>
         <% } %>
        
        </table>
         
         
        <%  
            }
        if ( Vaadin.Category.ALL.name().equals(cat) || Vaadin.Category.ACTIONS.name().equals(cat)) {     
            Vaadin.ActionStat actions = (Vaadin.ActionStat)pageContext.getAttribute(Vaadin.ACTIONS); 
            if  ( showUnique){ 
            pageContext.setAttribute("vaadinActionsUniqueUsers", actions.getDisplayPresentation(actions.getUniqueUsers()));
            }
            if  ( showOverall){
            pageContext.setAttribute("vaadinActionsOverall", actions.getDisplayPresentation(actions.getOverallUsage()));
            }
        %>
            <div align="center">
                <% if  ( showUnique){ %>
            <ui:pie collection="vaadinActionsUniqueUsers" category="key" value="value" 
                title="Vaadin Project Actions (unique users)" resolution="600x200" />
            <% } 
                if  ( showOverall){ %>
            <ui:pie collection="vaadinActionsOverall" category="key" value="value" 
                title="Vaadin Project Actions (overall)" resolution="600x200" />
            <% } %>
            </div>
        <table cellpadding="5" width="100%" >
        <thead class="tblheader">
            <th width="20%">Vaadin Actions (popup for project node)</th>
            <% if  ( showUnique){ %>
            <th>Unique users</th>
            <% } 
                if  ( showOverall){ %>
            <th>Overall</th>
            <% } %>
        </thead>
        <%  for(String key : actions.getOverallUsage().keySet()) { %>
            <tr>
                <td class="tbltd1"><% out.println(actions.getDisplayName(key)); %></td>
                <% if  ( showUnique){ %>
                <td class="tbltd1"><% out.println(actions.getUniqueUsers().get(key)); %></td>
                <% } 
                if  ( showOverall){ %>
                <td class="tbltd1"><% out.println(actions.getOverallUsage().get(key)); %></td>
                <% } %>
            </tr>
         <% } %>
        
        </table>
        
         
        <% 
            }
        if ( Vaadin.Category.ALL.name().equals(cat) || Vaadin.Category.HINTS.name().equals(cat)) {        
            Vaadin.FixStat fixes = (Vaadin.FixStat)pageContext.getAttribute(Vaadin.FIXES); 
            if  ( showUnique){
            pageContext.setAttribute("vaadinFixesUniqueUsers", fixes.getDisplayPresentation(fixes.getUniqueUsers()));
            }
            if  ( showOverall){
            pageContext.setAttribute("vaadinFixesOverall", fixes.getDisplayPresentation(fixes.getOverallUsage()));
            }
        %>
        <div align="center">
            <% if  ( showUnique){ %>
            <ui:pie collection="vaadinFixesUniqueUsers" category="key" value="value" 
                title="Vaadin Hints (unique users)" resolution="600x200" />
            <% } 
                if  ( showOverall){ %>
            <ui:pie collection="vaadinFixesOverall" category="key" value="value" 
                title="Vaadin Hints (overall)" resolution="600x200" />
            <% } %>
            </div>
        <table cellpadding="5" width="100%" >
        <thead class="tblheader">
            <th width="20%">Vaadin Hints</th>
            <% if  ( showUnique){ %>
            <th>Unique users</th>
            <% } 
                if  ( showOverall){ %>
            <th>Overall</th>
            <% } %>
        </thead>
        <%  for(String key : fixes.getOverallUsage().keySet()) { %>
            <tr>
                <td class="tbltd1"><% out.println(fixes.getDisplayName(key)); %></td>
                <% if  ( showUnique){ %>
                <td class="tbltd1"><% out.println(fixes.getUniqueUsers().get(key)); %></td>
                <% } 
                if  ( showOverall){ %>
                <td class="tbltd1"><% out.println(fixes.getOverallUsage().get(key)); %></td>
                <% } %>
            </tr>
         <% } %>
        
        </table>
         
        <%   } 
        %>
        

<%@include file="/WEB-INF/jspf/footer.jspf" %> 
