package org.netbeans.examples.customsaveaction;

import java.io.IOException;
import org.openide.ErrorManager;
import org.openide.cookies.SaveCookie;
import org.openide.nodes.Node;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;
import org.openide.util.actions.CookieAction;

public final class CustomSaveAction extends CookieAction {
    
    protected void performAction(Node[] selection) {
        for (int i=0; i < selection.length; i++) {
            SaveCookie c =(SaveCookie) selection[0].getCookie(SaveCookie.class);
            if (c != null) {
                try {
                    c.save();
                } catch (IOException ex) {
                    ErrorManager.getDefault().notify(ex);
                }
            }
        }
    }
    
    protected int mode() {
        return CookieAction.MODE_ALL;
    }
    
    public String getName() {
        return NbBundle.getMessage(CustomSaveAction.class, 
                "CTL_CustomSaveAction");
    }
    
    protected Class[] cookieClasses() {
        return new Class[] {
            SaveCookie.class
        };
    }
    
    protected String iconResource() {
        return "org/netbeans/examples/customsaveaction/mficon.png";
    }
    
    public HelpCtx getHelpCtx() {
        return HelpCtx.DEFAULT_HELP;
    }
    
    protected boolean asynchronous() {
        return false;
    }
}

