/*
 * ManifestEditor.java
 *
 * Created on October 25, 2006, 12:06 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.netbeans.modules.manifestlexer;

import java.io.IOException;
import java.util.logging.Logger;
import org.openide.cookies.EditCookie;
import org.openide.cookies.EditorCookie;
import org.openide.cookies.OpenCookie;
import org.openide.cookies.SaveCookie;
import org.openide.filesystems.FileLock;
import org.openide.filesystems.FileObject;
import org.openide.text.DataEditorSupport;

/**
 *
 * @author Geertjan Wielenga
 */
public class ManifestEditor extends DataEditorSupport
        implements OpenCookie, EditorCookie, EditCookie {
    private static Logger LOG = Logger.getLogger(ManifestEditor.class.getName());
    
    public ManifestEditor(ManifestDataObject obj) {
        super(obj, new MyEnv(obj));
    }
    
    public static ManifestEditor create(ManifestDataObject obj) {
        return new ManifestEditor(obj);
    }
    
    protected boolean notifyModified() {
        boolean retValue;
        retValue = super.notifyModified();
        if (retValue) {
            ManifestDataObject obj = (ManifestDataObject)getDataObject();
            obj.ic.add(env);
        }
        return retValue;
    }
    
    protected void notifyUnmodified() {
        super.notifyUnmodified();
        
        ManifestDataObject obj = (ManifestDataObject)getDataObject();
        obj.ic.remove(env);
    }
    
    
    private static final class MyEnv extends DataEditorSupport.Env
            implements SaveCookie {
        public MyEnv(ManifestDataObject obj) {
            super(obj);
        }
        
        public void save() throws IOException {
            ManifestEditor ed = (ManifestEditor)this.findCloneableOpenSupport();
            ed.saveDocument();
        }
        
        protected FileObject getFile() {
            return super.getDataObject().getPrimaryFile();
        }
        
        protected FileLock takeLock() throws IOException {
            return ((ManifestDataObject)super.getDataObject()).getPrimaryEntry().takeLock();
        }
        
    }
    
}
