/*
 * CustomerContextAction.java
 *
 * Created on September 21, 2006, 5:40 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package org.netbeans.examples.masterdetail.actions;

import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.ImageIcon;
import org.netbeans.examples.masterdetail.api.Customer;
import org.openide.util.ContextAwareAction;
import org.openide.util.Lookup;
import org.openide.util.LookupEvent;
import org.openide.util.LookupListener;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;

/**
 *
 * @author Tim
 */
public final class CustomerContextAction extends AbstractAction implements ContextAwareAction, LookupListener {
    private final Lookup lkp;
    private Lookup.Result result;
    /** Creates a new instance of CustomerContextAction */
    public CustomerContextAction() {
        this (Utilities.actionsGlobalContext());
    }
    
    private CustomerContextAction (Lookup lkp) {
        putValue (NAME, NbBundle.getMessage (CustomerContextAction.class,
                "LBL_ACTION"));
        putValue (SMALL_ICON, new ImageIcon (Utilities.loadImage(
                "org/netbeans/examples/masterdetail/actions/" +
                "clearCustomer.png")));
        putValue("noIconInMenu", Boolean.TRUE);
        
        this.lkp = lkp;
        result = lkp.lookup(new Lookup.Template(Customer.class));
        result.addLookupListener (this);
        
        resultChanged(null);
    }

    public void actionPerformed(ActionEvent e) {
        Customer customer = (Customer )lkp.lookup(Customer.class);
        assert customer != null;
        customer.clear();
    }

    public Action createContextAwareInstance(Lookup lookup) {
        return new CustomerContextAction (lookup);
    }

    public void resultChanged(LookupEvent lookupEvent) {
        setEnabled (result.allInstances().size() > 0);
    }
    
}
