/*
 * CustomerPanel.java
 *
 * Created on September 21, 2006, 4:03 PM
 */

package org.netbeans.examples.masterdetail.nodes;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyVetoException;
import javax.swing.JComboBox;
import javax.swing.SwingUtilities;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.swing.text.JTextComponent;
import org.netbeans.examples.masterdetail.api.Customer;
import org.openide.explorer.ExplorerManager;
import org.openide.nodes.Node;

/**
 *
 * @author  Tim
 */
final class CustomerPanel extends javax.swing.JPanel implements PropertyChangeListener, DocumentListener, ActionListener {
    
    /** Creates new form CustomerPanel */
    public CustomerPanel() {
        initComponents();
        Component[] c = getComponents();
        for (int i = 0; i < c.length; i++) {
            if (c[i] instanceof JTextComponent) {
                ((JTextComponent) c[i]).getDocument().addDocumentListener (
                        this );
                
                ((JTextComponent) c[i]).getDocument().putProperty("propName",
                        c[i].getName());
            }
        }
        stateCombo.addActionListener(this);
    }
    
    public void addNotify() {
        super.addNotify();
        ExplorerManager.Provider prov = (ExplorerManager.Provider)
                SwingUtilities.getAncestorOfClass(
                ExplorerManager.Provider.class, this);
        
        if (prov != null) {
            prov.getExplorerManager().addPropertyChangeListener( this );
            sync(null, false);
        }
    }

    public void removeNotify() {
        ExplorerManager.Provider prov = (ExplorerManager.Provider) 
                SwingUtilities.getAncestorOfClass(
                ExplorerManager.Provider.class, this);
        
        if (prov != null) {
            prov.getExplorerManager().removePropertyChangeListener ( this );
        }
        super.removeNotify();
        setCustomer (null);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        firstNameLbl = new javax.swing.JLabel();
        firstNameField = new javax.swing.JTextField();
        lastNameLbl = new javax.swing.JLabel();
        lastNameField = new javax.swing.JTextField();
        addressLbl = new javax.swing.JLabel();
        addressField = new javax.swing.JTextField();
        cityLbl = new javax.swing.JLabel();
        cityField = new javax.swing.JTextField();
        stateLbl = new javax.swing.JLabel();
        stateCombo = new javax.swing.JComboBox();
        postalCodeLbl = new javax.swing.JLabel();
        postalCodeField = new javax.swing.JTextField();
        problemLbl = new javax.swing.JLabel();

        firstNameLbl.setLabelFor(firstNameField);
        firstNameLbl.setText("First Name");

        firstNameField.setName(Customer.PROP_FIRST_NAME);

        lastNameLbl.setLabelFor(lastNameField);
        lastNameLbl.setText("Last Name");

        lastNameField.setName(Customer.PROP_LAST_NAME);

        addressLbl.setLabelFor(addressField);
        addressLbl.setText("Address");

        addressField.setName(Customer.PROP_ADDRESS);

        cityLbl.setLabelFor(cityField);
        cityLbl.setText("City");

        cityField.setName(Customer.PROP_CITY
        );

        stateLbl.setLabelFor(stateCombo);
        stateLbl.setText("State");

        stateCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "AL", "AK", "MS", "MI", "MN", "TX" }));
        stateCombo.setName(Customer.PROP_STATE);

        postalCodeLbl.setLabelFor(postalCodeField);
        postalCodeLbl.setText("Zip");

        postalCodeField.setName(Customer.PROP_POSTAL_CODE);

        problemLbl.setBackground(java.awt.Color.red);
        problemLbl.setText(" ");
        problemLbl.setBorder(javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createEmptyBorder(5, 0, 0, 0), javax.swing.BorderFactory.createCompoundBorder(javax.swing.BorderFactory.createMatteBorder(1, 0, 0, 0, javax.swing.UIManager.getDefaults().getColor("controlShadow")), javax.swing.BorderFactory.createMatteBorder(1, 0, 0, 0, javax.swing.UIManager.getDefaults().getColor("controlHighlight")))));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(firstNameLbl)
                    .addComponent(addressLbl)
                    .addComponent(cityLbl))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(firstNameField, javax.swing.GroupLayout.DEFAULT_SIZE, 156, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lastNameLbl))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(cityField, javax.swing.GroupLayout.DEFAULT_SIZE, 156, Short.MAX_VALUE)
                        .addGap(28, 28, 28)
                        .addComponent(stateLbl)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lastNameField, javax.swing.GroupLayout.DEFAULT_SIZE, 212, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(stateCombo, 0, 37, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(postalCodeLbl)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(postalCodeField, javax.swing.GroupLayout.DEFAULT_SIZE, 153, Short.MAX_VALUE)))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addGap(65, 65, 65)
                .addComponent(addressField, javax.swing.GroupLayout.DEFAULT_SIZE, 426, Short.MAX_VALUE)
                .addGap(10, 10, 10))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(problemLbl, javax.swing.GroupLayout.DEFAULT_SIZE, 481, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(firstNameLbl)
                    .addComponent(firstNameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lastNameLbl)
                    .addComponent(lastNameField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(addressLbl)
                    .addComponent(addressField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cityLbl)
                    .addComponent(cityField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(stateCombo, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(postalCodeLbl)
                    .addComponent(postalCodeField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(stateLbl))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(problemLbl)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    public void propertyChange(PropertyChangeEvent evt) {
        System.err.println("GOT A CHANGE " + evt.getPropertyName());
        if (ExplorerManager.PROP_SELECTED_NODES.equals(evt.getPropertyName())) {
            ExplorerManager mgr = (ExplorerManager) evt.getSource();
            Node[] nds = mgr.getSelectedNodes();

            setNode (nds.length == 0 ? null : nds[0]);
        } else {
            sync(evt.getPropertyName(), false);
        }
    }
    
    private void setNode (Node n) {
        Customer customer = n == null ? null : 
            (Customer) n.getLookup().lookup(Customer.class);
        System.err.println("FOUND CUSTOMER " + customer + " in " + n);
        setCustomer (customer);
     }
    
    private Customer customer;
    private void setCustomer (Customer c) {
        if (((c == null) != (this.customer == null)) || (c !=null &&
                !c.equals(this.customer))) {
            if (this.customer != null) {
                this.customer.removePropertyChangeListener(this);
            }
            this.customer = c;
            sync (null, false);
            if (c != null) {
                this.customer.addPropertyChangeListener (this);
            }
        }
        Component[] comps = getComponents();
        for (int i = 0; i < comps.length; i++) {
            comps [i].setEnabled (c != null);
        }
    }

    public void insertUpdate(DocumentEvent e) {
        String propName = (String) e.getDocument().getProperty("propName");
        sync (propName, true);
    }

    public void removeUpdate(DocumentEvent e) {
        String propName = (String) e.getDocument().getProperty("propName");
        sync (propName, true);
    }

    public void changedUpdate(DocumentEvent e) {
        String propName = (String) e.getDocument().getProperty("propName");
        sync (propName, true);
    }

    public void actionPerformed(ActionEvent e) {
        sync (((JComboBox) e.getSource()).getName(), true);
    }
    
    private boolean syncing = false;
    private void sync(String prop, boolean updateCustomer) {
        if (syncing) {
            return;
        }
        syncing = true;
        try {
            if (updateCustomer) {
                if (prop != null) {
                    if (!Customer.PROP_STATE.equals(prop)) {
                        Component[] c = getComponents();
                        problemLbl.setText (" ");
                        for (int i = 0; i < c.length; i++) {
                            if (c[i] instanceof JTextComponent) {
                                String name = c[i].getName();
                                if (prop.equals(name)) {
                                    try {
                                        customer.setProperty(name,
                                                ((JTextComponent)c[i]).getText());
                                    } catch (PropertyVetoException ex) {
                                        setProblem (ex.getMessage());
                                    }
                                }
                            }
                        }
                    }
                }
            } else {
                if (customer == null) {
                    customer = new Customer();
                }
                firstNameField.setText(customer.getFirstName());
                lastNameField.setText (customer.getLastName());
                addressField.setText(customer.getAddress());
                cityField.setText(customer.getCity());
                postalCodeField.setText(customer.getPostalCode());
                stateCombo.setSelectedItem(customer.getState());
                setProblem (null);
            }
        } finally {
            syncing = false;
        }
    }

    private void setProblem(String string) {
        problemLbl.setText (string == null ? " " : string);
    }
    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField addressField;
    private javax.swing.JLabel addressLbl;
    private javax.swing.JTextField cityField;
    private javax.swing.JLabel cityLbl;
    private javax.swing.JTextField firstNameField;
    private javax.swing.JLabel firstNameLbl;
    private javax.swing.JTextField lastNameField;
    private javax.swing.JLabel lastNameLbl;
    private javax.swing.JTextField postalCodeField;
    private javax.swing.JLabel postalCodeLbl;
    private javax.swing.JLabel problemLbl;
    private javax.swing.JComboBox stateCombo;
    private javax.swing.JLabel stateLbl;
    // End of variables declaration//GEN-END:variables

    
}
