-- ============================

-- This file was created using Derby's dblook utility.
-- Timestamp: 2007-02-14 18:55:55.334
-- Source database is: pluginsystem
-- Connection URL is: jdbc:derby://localhost:1527/pluginsystem;user=admin;password=admin
-- appendLogs: false

-- ----------------------------------------------
-- DDL Statements for schemas
-- ----------------------------------------------
connect 'jdbc:derby://localhost:1527/pluginsystem;create=true';

drop table "ADMIN"."DISPLAYCATEGORYIMPL";
drop table "ADMIN"."SEQUENCE";
drop table "ADMIN"."OTHERCATEGORYIMPL";
drop table "ADMIN"."RATINGIMPL";
drop table "ADMIN"."COMMENTIMPL";
drop table "ADMIN"."PLUGINIMPL";

drop schema "ADMIN";

CREATE SCHEMA "ADMIN";

-- ----------------------------------------------
-- DDL Statements for tables
-- ----------------------------------------------

CREATE TABLE "ADMIN"."DISPLAYCATEGORYIMPL" ("ID" INTEGER NOT NULL, "DISPLAYCATEGORY_NAME" VARCHAR(255));

CREATE TABLE "ADMIN"."PLUGINIMPL" ("PLUGINID" BIGINT NOT NULL, "DATE_ADDED" DATE, "DATE_LAST_UPDATED" DATE, "DESCRIPTION" VARCHAR(500), "NBM_FILENAME" VARCHAR(255), "HOME_PAGE_URL" VARCHAR(255), "QUALITY_LEVEL" VARCHAR(255), "AUTHOR_USERID" VARCHAR(255), "VERSION" VARCHAR(255), "TARGET_PLATFORMS" VARCHAR(255), "NBM_URL" VARCHAR(255), "DOWNLOADS" BIGINT, "CATEGORYID" INTEGER, "SUMMARY" VARCHAR(500), "DOWNLOAD_SIZE" BIGINT, "LICENSE_TYPE" VARCHAR(255), "IMAGE_FILENAME" VARCHAR(255), "PLUGIN_NAME" VARCHAR(255), "VERSIONS_SUPPORTED" VARCHAR(255), "KEYWORDS" VARCHAR(255));

CREATE TABLE "ADMIN"."SEQUENCE" ("SEQ_NAME" VARCHAR(50) NOT NULL, "SEQ_COUNT" DECIMAL(5,0));

CREATE TABLE "ADMIN"."OTHERCATEGORYIMPL" ("ID" BIGINT NOT NULL, "CATEGORYNAME" VARCHAR(255), "PLUGIN_PLUGINID" BIGINT);

CREATE TABLE "ADMIN"."RATINGIMPL" ("ID" BIGINT NOT NULL, "USERID" VARCHAR(255), "DATE_RATED" DATE, "RATING_LEVEL" INTEGER, "PLUGIN_PLUGINID" BIGINT);

CREATE TABLE "ADMIN"."COMMENTIMPL" ("ID" BIGINT NOT NULL, "COMMENT_SUMMARY" VARCHAR(255), "USERID" VARCHAR(255), "TITLE" VARCHAR(255), "DATE_ENTERED" DATE, "PLUGIN_PLUGINID" BIGINT);

-- ----------------------------------------------
-- DDL Statements for keys
-- ----------------------------------------------

-- primary/unique
ALTER TABLE "ADMIN"."DISPLAYCATEGORYIMPL" ADD CONSTRAINT "SQL070212112255080" PRIMARY KEY ("ID");

ALTER TABLE "ADMIN"."RATINGIMPL" ADD CONSTRAINT "SQL070212112255270" PRIMARY KEY ("ID");

ALTER TABLE "ADMIN"."SEQUENCE" ADD CONSTRAINT "SQL070205103241990" PRIMARY KEY ("SEQ_NAME");

ALTER TABLE "ADMIN"."COMMENTIMPL" ADD CONSTRAINT "SQL070212112255190" PRIMARY KEY ("ID");

ALTER TABLE "ADMIN"."PLUGINIMPL" ADD CONSTRAINT "SQL070212112255310" PRIMARY KEY ("PLUGINID");

ALTER TABLE "ADMIN"."OTHERCATEGORYIMPL" ADD CONSTRAINT "SQL070212112255250" PRIMARY KEY ("ID");

-- foreign
ALTER TABLE "ADMIN"."RATINGIMPL" ADD CONSTRAINT "RTNGMPLPLGNPLGINID" FOREIGN KEY ("PLUGIN_PLUGINID") REFERENCES "ADMIN"."PLUGINIMPL" ("PLUGINID") ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER TABLE "ADMIN"."COMMENTIMPL" ADD CONSTRAINT "CMMNTMPLPLGNPLGNID" FOREIGN KEY ("PLUGIN_PLUGINID") REFERENCES "ADMIN"."PLUGINIMPL" ("PLUGINID") ON DELETE NO ACTION ON UPDATE NO ACTION;

ALTER TABLE "ADMIN"."OTHERCATEGORYIMPL" ADD CONSTRAINT "THRCTGRYMPLGNPLGND" FOREIGN KEY ("PLUGIN_PLUGINID") REFERENCES "ADMIN"."PLUGINIMPL" ("PLUGINID") ON DELETE NO ACTION ON UPDATE NO ACTION;

