/**
 *
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 **/
package pluginportal;

import com.sun.data.provider.RowKey;
import com.sun.data.provider.impl.ObjectArrayDataProvider;
import com.sun.data.provider.impl.TableRowDataProvider;
import com.sun.j2ee.blueprints.ui.rating.RatingComponent;
import com.sun.rave.web.ui.appbase.AbstractPageBean;
import com.sun.webui.jsf.component.Body;
import com.sun.webui.jsf.component.Button;
import com.sun.webui.jsf.component.Form;
import com.sun.webui.jsf.component.Head;
import com.sun.webui.jsf.component.Html;
import com.sun.webui.jsf.component.Hyperlink;
import com.sun.webui.jsf.component.ImageComponent;
import com.sun.webui.jsf.component.ImageHyperlink;
import com.sun.webui.jsf.component.Link;
import com.sun.webui.jsf.component.Markup;
import com.sun.webui.jsf.component.Page;
import com.sun.webui.jsf.component.PanelGroup;
import com.sun.webui.jsf.component.PanelLayout;
import com.sun.webui.jsf.component.StaticText;
import com.sun.webui.jsf.component.Table;
import com.sun.webui.jsf.component.TableColumn;
import com.sun.webui.jsf.component.TableRowGroup;
import java.util.ArrayList;
import java.util.Iterator;
import javax.faces.FacesException;
import org.netbeans.pluginportal.system.SystemFileUtils;
import org.netbeans.pluginportal.ui.MyPlugin;
import org.netbeans.pluginportal.system.Plugin;
import org.netbeans.pluginportal.system.Rating;

/**
 * <p>Page bean that corresponds to a similarly named JSP page.  This
 * class contains component definitions (and initialization code) for
 * all components that you have defined on this page, as well as
 * lifecycle methods and event handlers where you may add behavior
 * to respond to incoming events.</p>
 *
 *@author David Botterill
 */
public class MyPluginsPage extends AbstractPageBean {
    // <editor-fold defaultstate="collapsed" desc="Managed Component Definition">
    private int __placeholder;
    
    /**
     * <p>Automatically managed component initialization.  <strong>WARNING:</strong>
     * This method is automatically generated, so any user-specified code inserted
     * here is subject to being replaced.</p>
     */
    private void _init() throws Exception {
        pluginDataProvider.setArray((java.lang.Object[])getValue("#{MyPluginsPage.myPlugins}"));
    }
    
    private Page page1 = new Page();
    
    public Page getPage1() {
        return page1;
    }
    
    public void setPage1(Page p) {
        this.page1 = p;
    }
    
    private Html html1 = new Html();
    
    public Html getHtml1() {
        return html1;
    }
    
    public void setHtml1(Html h) {
        this.html1 = h;
    }
    
    private Head head1 = new Head();
    
    public Head getHead1() {
        return head1;
    }
    
    public void setHead1(Head h) {
        this.head1 = h;
    }
    
    private Link link1 = new Link();
    
    public Link getLink1() {
        return link1;
    }
    
    public void setLink1(Link l) {
        this.link1 = l;
    }
    
    private Body body1 = new Body();
    
    public Body getBody1() {
        return body1;
    }
    
    public void setBody1(Body b) {
        this.body1 = b;
    }
    
    private Form form1 = new Form();
    
    public Form getForm1() {
        return form1;
    }
    
    public void setForm1(Form f) {
        this.form1 = f;
    }
    
    private PanelLayout center_container = new PanelLayout();
    
    public PanelLayout getCenter_container() {
        return center_container;
    }
    
    public void setCenter_container(PanelLayout pl) {
        this.center_container = pl;
    }
    
    private PanelLayout page_border = new PanelLayout();
    
    public PanelLayout getPage_border() {
        return page_border;
    }
    
    public void setPage_border(PanelLayout pl) {
        this.page_border = pl;
    }
    
    private PanelLayout fixed_tabs = new PanelLayout();
    
    public PanelLayout getFixed_tabs() {
        return fixed_tabs;
    }
    
    public void setFixed_tabs(PanelLayout pl) {
        this.fixed_tabs = pl;
    }
    
    private ImageComponent image1 = new ImageComponent();
    
    public ImageComponent getImage1() {
        return image1;
    }
    
    public void setImage1(ImageComponent ic) {
        this.image1 = ic;
    }
    
    private ImageComponent image2 = new ImageComponent();
    
    public ImageComponent getImage2() {
        return image2;
    }
    
    public void setImage2(ImageComponent ic) {
        this.image2 = ic;
    }
    
    private ImageHyperlink imageHyperlink1 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink1() {
        return imageHyperlink1;
    }
    
    public void setImageHyperlink1(ImageHyperlink ih) {
        this.imageHyperlink1 = ih;
    }
    
    private ImageHyperlink imageHyperlink2 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink2() {
        return imageHyperlink2;
    }
    
    public void setImageHyperlink2(ImageHyperlink ih) {
        this.imageHyperlink2 = ih;
    }
    
    private ImageHyperlink imageHyperlink3 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink3() {
        return imageHyperlink3;
    }
    
    public void setImageHyperlink3(ImageHyperlink ih) {
        this.imageHyperlink3 = ih;
    }
    
    private ImageHyperlink imageHyperlink4 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink4() {
        return imageHyperlink4;
    }
    
    public void setImageHyperlink4(ImageHyperlink ih) {
        this.imageHyperlink4 = ih;
    }
    
    private ImageHyperlink imageHyperlink5 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink5() {
        return imageHyperlink5;
    }
    
    public void setImageHyperlink5(ImageHyperlink ih) {
        this.imageHyperlink5 = ih;
    }
    
    private ImageHyperlink imageHyperlink6 = new ImageHyperlink();
    
    public ImageHyperlink getImageHyperlink6() {
        return imageHyperlink6;
    }
    
    public void setImageHyperlink6(ImageHyperlink ih) {
        this.imageHyperlink6 = ih;
    }
    
    private PanelLayout fixed_contentarea = new PanelLayout();
    
    public PanelLayout getFixed_contentarea() {
        return fixed_contentarea;
    }
    
    public void setFixed_contentarea(PanelLayout pl) {
        this.fixed_contentarea = pl;
    }
    
    private PanelLayout fixed_contextbox1 = new PanelLayout();
    
    public PanelLayout getFixed_contextbox1() {
        return fixed_contextbox1;
    }
    
    public void setFixed_contextbox1(PanelLayout pl) {
        this.fixed_contextbox1 = pl;
    }
    
    private PanelLayout topMyPluginPanel = new PanelLayout();
    
    public PanelLayout getTopMyPluginPanel() {
        return topMyPluginPanel;
    }
    
    public void setTopMyPluginPanel(PanelLayout pl) {
        this.topMyPluginPanel = pl;
    }
    
    private Markup markup1 = new Markup();
    
    public Markup getMarkup1() {
        return markup1;
    }
    
    public void setMarkup1(Markup m) {
        this.markup1 = m;
    }
    
    private StaticText txtMyPlugins = new StaticText();
    
    public StaticText getTxtMyPlugins() {
        return txtMyPlugins;
    }
    
    public void setTxtMyPlugins(StaticText st) {
        this.txtMyPlugins = st;
    }
    
    private Markup markup2 = new Markup();
    
    public Markup getMarkup2() {
        return markup2;
    }
    
    public void setMarkup2(Markup m) {
        this.markup2 = m;
    }
    
    private PanelLayout bottomMyPluginPanel = new PanelLayout();
    
    public PanelLayout getBottomMyPluginPanel() {
        return bottomMyPluginPanel;
    }
    
    public void setBottomMyPluginPanel(PanelLayout pl) {
        this.bottomMyPluginPanel = pl;
    }
    
    private PanelLayout fixed_footer = new PanelLayout();
    
    public PanelLayout getFixed_footer() {
        return fixed_footer;
    }
    
    public void setFixed_footer(PanelLayout pl) {
        this.fixed_footer = pl;
    }
    
    private PanelLayout footer_text1 = new PanelLayout();
    
    public PanelLayout getFooter_text1() {
        return footer_text1;
    }
    
    public void setFooter_text1(PanelLayout pl) {
        this.footer_text1 = pl;
    }
    
    private PanelLayout footer_navig1 = new PanelLayout();
    
    public PanelLayout getFooter_navig1() {
        return footer_navig1;
    }
    
    public void setFooter_navig1(PanelLayout pl) {
        this.footer_navig1 = pl;
    }
    
    private StaticText staticText10 = new StaticText();
    
    public StaticText getStaticText10() {
        return staticText10;
    }
    
    public void setStaticText10(StaticText st) {
        this.staticText10 = st;
    }
    
    private StaticText staticText11 = new StaticText();
    
    public StaticText getStaticText11() {
        return staticText11;
    }
    
    public void setStaticText11(StaticText st) {
        this.staticText11 = st;
    }
    
    private Hyperlink hyperlink4 = new Hyperlink();
    
    public Hyperlink getHyperlink4() {
        return hyperlink4;
    }
    
    public void setHyperlink4(Hyperlink h) {
        this.hyperlink4 = h;
    }
    
    private StaticText staticText12 = new StaticText();
    
    public StaticText getStaticText12() {
        return staticText12;
    }
    
    public void setStaticText12(StaticText st) {
        this.staticText12 = st;
    }
    
    private Hyperlink hyperlink5 = new Hyperlink();
    
    public Hyperlink getHyperlink5() {
        return hyperlink5;
    }
    
    public void setHyperlink5(Hyperlink h) {
        this.hyperlink5 = h;
    }
    
    private StaticText staticText13 = new StaticText();
    
    public StaticText getStaticText13() {
        return staticText13;
    }
    
    public void setStaticText13(StaticText st) {
        this.staticText13 = st;
    }
    
    private StaticText staticText14 = new StaticText();
    
    public StaticText getStaticText14() {
        return staticText14;
    }
    
    public void setStaticText14(StaticText st) {
        this.staticText14 = st;
    }
    
    private Hyperlink hyperlink6 = new Hyperlink();
    
    public Hyperlink getHyperlink6() {
        return hyperlink6;
    }
    
    public void setHyperlink6(Hyperlink h) {
        this.hyperlink6 = h;
    }
    
    private StaticText staticText15 = new StaticText();
    
    public StaticText getStaticText15() {
        return staticText15;
    }
    
    public void setStaticText15(StaticText st) {
        this.staticText15 = st;
    }
    
    private Hyperlink hyperlink7 = new Hyperlink();
    
    public Hyperlink getHyperlink7() {
        return hyperlink7;
    }
    
    public void setHyperlink7(Hyperlink h) {
        this.hyperlink7 = h;
    }
    
    private StaticText staticText16 = new StaticText();
    
    public StaticText getStaticText16() {
        return staticText16;
    }
    
    public void setStaticText16(StaticText st) {
        this.staticText16 = st;
    }
    
    private Hyperlink hyperlink8 = new Hyperlink();
    
    public Hyperlink getHyperlink8() {
        return hyperlink8;
    }
    
    public void setHyperlink8(Hyperlink h) {
        this.hyperlink8 = h;
    }
    
    private PanelLayout tof1 = new PanelLayout();
    
    public PanelLayout getTof1() {
        return tof1;
    }
    
    public void setTof1(PanelLayout pl) {
        this.tof1 = pl;
    }
    
    private StaticText staticText17 = new StaticText();
    
    public StaticText getStaticText17() {
        return staticText17;
    }
    
    public void setStaticText17(StaticText st) {
        this.staticText17 = st;
    }
    
    private Hyperlink hyperlink9 = new Hyperlink();
    
    public Hyperlink getHyperlink9() {
        return hyperlink9;
    }
    
    public void setHyperlink9(Hyperlink h) {
        this.hyperlink9 = h;
    }
    
    private Table table1 = new Table();
    
    public Table getTable1() {
        return table1;
    }
    
    public void setTable1(Table t) {
        this.table1 = t;
    }
    
    private TableRowGroup myPluginRowGroup = new TableRowGroup();
    
    public TableRowGroup getMyPluginRowGroup() {
        return myPluginRowGroup;
    }
    
    public void setMyPluginRowGroup(TableRowGroup trg) {
        this.myPluginRowGroup = trg;
    }
    
    private ObjectArrayDataProvider pluginDataProvider = new ObjectArrayDataProvider();
    
    public ObjectArrayDataProvider getPluginDataProvider() {
        return pluginDataProvider;
    }
    
    public void setPluginDataProvider(ObjectArrayDataProvider oadp) {
        this.pluginDataProvider = oadp;
    }
    
    private TableColumn tableColumn1 = new TableColumn();
    
    public TableColumn getTableColumn1() {
        return tableColumn1;
    }
    
    public void setTableColumn1(TableColumn tc) {
        this.tableColumn1 = tc;
    }
    
    private TableColumn tableColumn2 = new TableColumn();
    
    public TableColumn getTableColumn2() {
        return tableColumn2;
    }
    
    public void setTableColumn2(TableColumn tc) {
        this.tableColumn2 = tc;
    }
    
    private StaticText staticText3 = new StaticText();
    
    public StaticText getStaticText3() {
        return staticText3;
    }
    
    public void setStaticText3(StaticText st) {
        this.staticText3 = st;
    }
    
    private TableColumn tableColumn5 = new TableColumn();
    
    public TableColumn getTableColumn5() {
        return tableColumn5;
    }
    
    public void setTableColumn5(TableColumn tc) {
        this.tableColumn5 = tc;
    }
    
    private StaticText staticText6 = new StaticText();
    
    public StaticText getStaticText6() {
        return staticText6;
    }
    
    public void setStaticText6(StaticText st) {
        this.staticText6 = st;
    }
    
    private TableColumn tableColumn6 = new TableColumn();
    
    public TableColumn getTableColumn6() {
        return tableColumn6;
    }
    
    public void setTableColumn6(TableColumn tc) {
        this.tableColumn6 = tc;
    }
    
    private Hyperlink updateLink = new Hyperlink();
    
    public Hyperlink getUpdateLink() {
        return updateLink;
    }
    
    public void setUpdateLink(Hyperlink h) {
        this.updateLink = h;
    }
    
    private TableColumn tableColumn8 = new TableColumn();
    
    public TableColumn getTableColumn8() {
        return tableColumn8;
    }
    
    public void setTableColumn8(TableColumn tc) {
        this.tableColumn8 = tc;
    }
    
    private Hyperlink deleteLink = new Hyperlink();
    
    public Hyperlink getDeleteLink() {
        return deleteLink;
    }
    
    public void setDeleteLink(Hyperlink h) {
        this.deleteLink = h;
    }
    
    private Markup markup3 = new Markup();
    
    public Markup getMarkup3() {
        return markup3;
    }
    
    public void setMarkup3(Markup m) {
        this.markup3 = m;
    }
    
    private Markup markup4 = new Markup();
    
    public Markup getMarkup4() {
        return markup4;
    }
    
    public void setMarkup4(Markup m) {
        this.markup4 = m;
    }
    
    private Markup markup5 = new Markup();
    
    public Markup getMarkup5() {
        return markup5;
    }
    
    public void setMarkup5(Markup m) {
        this.markup5 = m;
    }
    
    private Hyperlink lnkName = new Hyperlink();
    
    public Hyperlink getLnkName() {
        return lnkName;
    }
    
    public void setLnkName(Hyperlink h) {
        this.lnkName = h;
    }
    
    private PanelLayout navig_breadcrumbs = new PanelLayout();
    
    public PanelLayout getNavig_breadcrumbs() {
        return navig_breadcrumbs;
    }
    
    public void setNavig_breadcrumbs(PanelLayout pl) {
        this.navig_breadcrumbs = pl;
    }
    
    private Hyperlink hyperlink2 = new Hyperlink();
    
    public Hyperlink getHyperlink2() {
        return hyperlink2;
    }
    
    public void setHyperlink2(Hyperlink h) {
        this.hyperlink2 = h;
    }
    
    private StaticText staticText2 = new StaticText();
    
    public StaticText getStaticText2() {
        return staticText2;
    }
    
    public void setStaticText2(StaticText st) {
        this.staticText2 = st;
    }
    
    private PanelGroup loginPanel1 = new PanelGroup();
    
    public PanelGroup getLoginPanel1() {
        return loginPanel1;
    }
    
    public void setLoginPanel1(PanelGroup pg) {
        this.loginPanel1 = pg;
    }
    
    private StaticText staticText5 = new StaticText();
    
    public StaticText getStaticText5() {
        return staticText5;
    }
    
    public void setStaticText5(StaticText st) {
        this.staticText5 = st;
    }
    
    private Hyperlink currentUser1 = new Hyperlink();
    
    public Hyperlink getCurrentUser1() {
        return currentUser1;
    }
    
    public void setCurrentUser1(Hyperlink h) {
        this.currentUser1 = h;
    }
    
    private Hyperlink txtLoginLogoff1 = new Hyperlink();
    
    public Hyperlink getTxtLoginLogoff1() {
        return txtLoginLogoff1;
    }
    
    public void setTxtLoginLogoff1(Hyperlink h) {
        this.txtLoginLogoff1 = h;
    }
    
    private Button btnAddPlugin = new Button();
    
    public Button getBtnAddPlugin() {
        return btnAddPlugin;
    }
    
    public void setBtnAddPlugin(Button b) {
        this.btnAddPlugin = b;
    }
    
    private Markup markup6 = new Markup();
    
    public Markup getMarkup6() {
        return markup6;
    }
    
    public void setMarkup6(Markup m) {
        this.markup6 = m;
    }
    
    private TableColumn tableColumn3 = new TableColumn();
    
    public TableColumn getTableColumn3() {
        return tableColumn3;
    }
    
    public void setTableColumn3(TableColumn tc) {
        this.tableColumn3 = tc;
    }
    
    private StaticText staticText1 = new StaticText();
    
    public StaticText getStaticText1() {
        return staticText1;
    }
    
    public void setStaticText1(StaticText st) {
        this.staticText1 = st;
    }

    private ImageHyperlink imageHyperlink7 = new ImageHyperlink();

    public ImageHyperlink getImageHyperlink7() {
        return imageHyperlink7;
    }

    public void setImageHyperlink7(ImageHyperlink ih) {
        this.imageHyperlink7 = ih;
    }
    
    // </editor-fold>
    
    /**
     * <p>Construct a new Page bean instance.</p>
     */
    public MyPluginsPage() {
    }
    
    /**
     * <p>Callback method that is called whenever a page is navigated to,
     * either directly via a URL, or indirectly via page navigation.
     * Customize this method to acquire resources that will be needed
     * for event handlers and lifecycle methods, whether or not this
     * page is performing post back processing.</p>
     *
     * <p>Note that, if the current request is a postback, the property
     * values of the components do <strong>not</strong> represent any
     * values submitted with this request.  Instead, they represent the
     * property values that were saved for this view when it was rendered.</p>
     */
    public void init() {
        // Perform initializations inherited from our superclass
        super.init();
        // Perform application initialization that must complete
        // *before* managed components are initialized
        // TODO - add your own initialiation code here
        
        // <editor-fold defaultstate="collapsed" desc="Managed Component Initialization">
        // Initialize automatically managed components
        // *Note* - this logic should NOT be modified
        try {
            _init();
        } catch (Exception e) {
            log("MyPluginsPage Initialization Failure", e);
            throw e instanceof FacesException ? (FacesException) e: new FacesException(e);
        }
        
        // </editor-fold>
        // Perform application initialization that must complete
        // *after* managed components are initialized
        // TODO - add your own initialization code here
        
        /**
         * We need to load the array of MyPlugin for the data provider.
         */
        Plugin [] tempPlugins = this.getApplicationBean1().getPluginSystem().getPluginsByAuthor(this.getSessionBean1().getCurrentUserId());
        if(null != tempPlugins) {
            ArrayList<MyPlugin> pluginList = new ArrayList();
            MyPlugin currentPlugin = null;
            for(int ii=0;ii < tempPlugins.length;ii++) {
                currentPlugin = new MyPlugin();
                currentPlugin.setPluginid(tempPlugins[ii].getPluginid());
                if(null != tempPlugins[ii].getDownloads()) {
                    currentPlugin.setDownloads(new Long(tempPlugins[ii].getDownloads()));
                } else {
                    currentPlugin.setDownloads(0L);
                }
                currentPlugin.setName(tempPlugins[ii].getPlugin_name());
                currentPlugin.setQuality(tempPlugins[ii].getQuality_level());
                if(null != tempPlugins[ii].getAverage_rating()) {
                    currentPlugin.setRating(tempPlugins[ii].getAverage_rating().toString() + "/5.0");
                } else {
                    currentPlugin.setRating("0.0/5.0");
                }
                currentPlugin.setVersion(tempPlugins[ii].getVersion());
                currentPlugin.setUrl("http://" + SystemFileUtils.getServerHost() + "/PluginPortal/faces/PluginDetailPage.jsp?pluginid=" + tempPlugins[ii].getPluginid());
                pluginList.add(currentPlugin);
            }
            
            this.setMyPlugins((MyPlugin [])pluginList.toArray(new MyPlugin[0]));
            pluginDataProvider.setArray(this.getMyPlugins());
        }
        
    }
    
    /**
     * <p>Callback method that is called after the component tree has been
     * restored, but before any event processing takes place.  This method
     * will <strong>only</strong> be called on a postback request that
     * is processing a form submit.  Customize this method to allocate
     * resources that will be required in your event handlers.</p>
     */
    public void preprocess() {
    }
    
    /**
     * <p>Callback method that is called just before rendering takes place.
     * This method will <strong>only</strong> be called for the page that
     * will actually be rendered (and not, for example, on a page that
     * handled a postback and then navigated to a different page).  Customize
     * this method to allocate resources that will be required for rendering
     * this page.</p>
     */
    public void prerender() {
    }
    
    /**
     * <p>Callback method that is called after rendering is completed for
     * this request, if <code>init()</code> was called (regardless of whether
     * or not this was the page that was actually rendered).  Customize this
     * method to release resources acquired in the <code>init()</code>,
     * <code>preprocess()</code>, or <code>prerender()</code> methods (or
     * acquired during execution of an event handler).</p>
     */
    public void destroy() {
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected SessionBean1 getSessionBean1() {
        return (SessionBean1)getBean("SessionBean1");
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected ApplicationBean1 getApplicationBean1() {
        return (ApplicationBean1)getBean("ApplicationBean1");
    }
    
    /**
     * <p>Return a reference to the scoped data bean.</p>
     */
    protected RequestBean1 getRequestBean1() {
        return (RequestBean1)getBean("RequestBean1");
    }
    
    public String btnLogin_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String btnCancel_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink4_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink5_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink6_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink7_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink8_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    public String hyperlink9_action() {
        // TODO: Process the action. Return value is a navigation
        // case name where null will return to the same page.
        
        return null;
    }
    
    /**
     * Holds value of property myPlugins.
     */
    private MyPlugin[] myPlugins;
    
    /**
     * Getter for property myPlugins.
     * @return Value of property myPlugins.
     */
    public MyPlugin[] getMyPlugins() {
        return this.myPlugins;
    }
    
    /**
     * Setter for property myPlugins.
     * @param myPlugins New value of property myPlugins.
     */
    public void setMyPlugins(MyPlugin[] myPlugins) {
        this.myPlugins = myPlugins;
    }
    
    public String updateLink_action() {
        RowKey rowKey = this.myPluginRowGroup.getRowKey();
        Long pluginid = (Long) this.pluginDataProvider.getValue("pluginid", rowKey);
        Plugin currentPlugin = this.getApplicationBean1().getPluginSystem().getPlugin(pluginid);
        getSessionBean1().setCurrentPlugin(currentPlugin);
        getRequestBean1().setTargetPlatforms(currentPlugin.getTarget_platforms());
        getSessionBean1().setReturnFromModifyPage("myplugins");
        return "modify";
    }
    
    public String promoteLink_action() {
        RowKey rowKey = this.myPluginRowGroup.getRowKey();
        Long pluginid = (Long) this.pluginDataProvider.getValue("pluginid", rowKey);
        Plugin currentPlugin = this.getApplicationBean1().getPluginSystem().getPlugin(pluginid);
        getSessionBean1().setCurrentPlugin(currentPlugin);
        return "promote";
    }
    
    public String deleteLink_action() {
        RowKey rowKey = this.myPluginRowGroup.getRowKey();
        Long pluginid = (Long) this.pluginDataProvider.getValue("pluginid", rowKey);
        Plugin currentPlugin = this.getApplicationBean1().getPluginSystem().getPlugin(pluginid);
        getSessionBean1().setCurrentPlugin(currentPlugin);
        return "delete";
    }
    
    public String lnkName_action() {
        RowKey rowKey = this.myPluginRowGroup.getRowKey();
        Long pluginid = (Long) this.pluginDataProvider.getValue("pluginid", rowKey);
        Plugin currentPlugin = this.getApplicationBean1().getPluginSystem().getPlugin(pluginid);
        getSessionBean1().setCurrentPlugin(currentPlugin);
        return "detail";
    }
    
    public String currentUser_action() {
        return "myplugins";
    }
    
    public String txtLoginLogoff_action() {
        if(this.getSessionBean1().isLoggedIn()) {
            this.getSessionBean1().logoff();
            return "home";
        } else {
            this.getSessionBean1().setReturnFromLoginPage("home");
            return "login";
        }
    }
    
    public String btnAddPlugin_action() {
        
        return "add";
    }
}

