/*
 * PluginTest.java
 * JUnit based test
 *
 * Created on January 31, 2007, 12:36 PM
 */

package org.netbeans.pluginportal.data.test;

import java.util.ArrayList;
import java.util.Date;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.PersistenceUnit;
import junit.framework.*;
import org.netbeans.pluginportal.data.PluginImpl;

/**
 *
 * @author David Botterill
 */
public class PluginTest extends TestCase {
    
    @PersistenceUnit
    EntityManagerFactory emf;
    
    public PluginTest(String testName) {
        super(testName);
    }
    
    protected void setUp() throws Exception {
        EntityManager em = emf.createEntityManager();
        PluginImpl plugin = new PluginImpl();
        plugin.setAuthor_userid("dbotterill");
        plugin.setCategoryid(1);
        plugin.setDate_added(new Date());
        plugin.setDate_last_updated(new Date());
        plugin.setDescription("Test Description");
        plugin.setDownloads(100L);
        plugin.setHome_page_url("http://www.davidbotterill.com");
        ArrayList<String> tempList = new ArrayList();
        tempList.add("keyword1");
        tempList.add("keyword2");
        plugin.setKeywords(tempList);
        plugin.setLicense_type("GPL");
        plugin.setNbm_filename("myplugin.nbm");
        plugin.setNbm_url("");
        tempList = new ArrayList();
        tempList.add("category1");
        tempList.add("category2");
        plugin.setOther_categories(tempList);
        plugin.setPlugin_name("David\'s Module");
        plugin.setQuality_level("alpha");
        plugin.setSummary("Test summary");
        tempList = new ArrayList();
        tempList.add("Windows");
        tempList.add("Mac OSX");
        plugin.setTarget_platforms(tempList);
        plugin.setVersion("1.0");
        tempList = new ArrayList();
        tempList.add("5.0");
        tempList.add("5.5");
        plugin.setVersions_supported(tempList);
        em.persist(plugin);
        
    }
    
    protected void tearDown() throws Exception {
    }
    
    /**
     * Test of getId method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetId() {
        System.out.println("getId");
        
        PluginImpl instance = new PluginImpl();
        
        Integer expResult = null;
        Integer result = instance.getId();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    
    /**
     * Test of getPlugin_name method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetPlugin_name() {
        System.out.println("getPlugin_name");
        
        PluginImpl instance = new PluginImpl();
        
        String expResult = "";
        String result = instance.getPlugin_name();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setPlugin_name method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetPlugin_name() {
        System.out.println("setPlugin_name");
        
        String plugin_name = "";
        PluginImpl instance = new PluginImpl();
        
        instance.setPlugin_name(plugin_name);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getDescription method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetDescription() {
        System.out.println("getDescription");
        
        PluginImpl instance = new PluginImpl();
        
        String expResult = "";
        String result = instance.getDescription();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setDescription method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetDescription() {
        System.out.println("setDescription");
        
        String description = "";
        PluginImpl instance = new PluginImpl();
        
        instance.setDescription(description);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getSummary method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetSummary() {
        System.out.println("getSummary");
        
        PluginImpl instance = new PluginImpl();
        
        String expResult = "";
        String result = instance.getSummary();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setSummary method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetSummary() {
        System.out.println("setSummary");
        
        String summary = "";
        PluginImpl instance = new PluginImpl();
        
        instance.setSummary(summary);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getHome_page_url method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetHome_page_url() {
        System.out.println("getHome_page_url");
        
        PluginImpl instance = new PluginImpl();
        
        String expResult = "";
        String result = instance.getHome_page_url();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setHome_page_url method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetHome_page_url() {
        System.out.println("setHome_page_url");
        
        String home_page_url = "";
        PluginImpl instance = new PluginImpl();
        
        instance.setHome_page_url(home_page_url);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getKeywords method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetKeywords() {
        System.out.println("getKeywords");
        
//        PluginImpl instance = new PluginImpl();
//
//        String expResult = "";
//        String result = instance.getKeywords();
//        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setKeywords method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetKeywords() {
        System.out.println("setKeywords");
        
//        String keywords = "";
//        PluginImpl instance = new PluginImpl();
//
//        instance.setKeywords(keywords);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getAuthor_userid method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetAuthor_userid() {
        System.out.println("getAuthor_userid");
        
        PluginImpl instance = new PluginImpl();
        
        String expResult = "";
        String result = instance.getAuthor_userid();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setAuthor_userid method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetAuthor_userid() {
        System.out.println("setAuthor_userid");
        
        String author_userid = "";
        PluginImpl instance = new PluginImpl();
        
        instance.setAuthor_userid(author_userid);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getLicense_type method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetLicense_type() {
        System.out.println("getLicense_type");
        
        PluginImpl instance = new PluginImpl();
        
        String expResult = "";
        String result = instance.getLicense_type();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setLicense_type method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetLicense_type() {
        System.out.println("setLicense_type");
        
        String license_type = "";
        PluginImpl instance = new PluginImpl();
        
        instance.setLicense_type(license_type);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getTarget_platforms method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetTarget_platforms() {
        System.out.println("getTarget_platforms");
        
//        PluginImpl instance = new PluginImpl();
//
//        String[] expResult = null;
//        String[] result = instance.getTarget_platforms();
//        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setTarget_platforms method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetTarget_platforms() {
        System.out.println("setTarget_platforms");
        
//        String[] target_platforms = null;
//        PluginImpl instance = new PluginImpl();
//
//        instance.setTarget_platforms(target_platforms);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getVersions_supported method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetVersions_supported() {
        System.out.println("getVersions_supported");
        
//        PluginImpl instance = new PluginImpl();
//
//        String[] expResult = null;
//        String[] result = instance.getVersions_supported();
//        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setVersions_supported method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetVersions_supported() {
        System.out.println("setVersions_supported");
        
//        String[] versions_supported = null;
//        PluginImpl instance = new PluginImpl();
//
//        instance.setVersions_supported(versions_supported);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getDownloads method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetDownloads() {
        System.out.println("getDownloads");
        
        PluginImpl instance = new PluginImpl();
        
        long expResult = 0L;
        long result = instance.getDownloads();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setDownloads method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetDownloads() {
        System.out.println("setDownloads");
        
        long downloads = 0L;
        PluginImpl instance = new PluginImpl();
        
        instance.setDownloads(downloads);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getDate_added method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetDate_added() {
        System.out.println("getDate_added");
        
        PluginImpl instance = new PluginImpl();
        
        Date expResult = null;
        Date result = instance.getDate_added();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setDate_added method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetDate_added() {
        System.out.println("setDate_added");
        
        Date date_added = null;
        PluginImpl instance = new PluginImpl();
        
        instance.setDate_added(date_added);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getDate_last_updated method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetDate_last_updated() {
        System.out.println("getDate_last_updated");
        
        PluginImpl instance = new PluginImpl();
        
        Date expResult = null;
        Date result = instance.getDate_last_updated();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setDate_last_updated method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetDate_last_updated() {
        System.out.println("setDate_last_updated");
        
        Date date_last_updated = null;
        PluginImpl instance = new PluginImpl();
        
        instance.setDate_last_updated(date_last_updated);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getNbm_filename method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetNbm_filename() {
        System.out.println("getNbm_filename");
        
        PluginImpl instance = new PluginImpl();
        
        String expResult = "";
        String result = instance.getNbm_filename();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setNbm_filename method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetNbm_filename() {
        System.out.println("setNbm_filename");
        
        String nbm_filename = "";
        PluginImpl instance = new PluginImpl();
        
        instance.setNbm_filename(nbm_filename);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getQuality_level method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetQuality_level() {
        System.out.println("getQuality_level");
        
        PluginImpl instance = new PluginImpl();
        
        String expResult = "";
        String result = instance.getQuality_level();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setQuality_level method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetQuality_level() {
        System.out.println("setQuality_level");
        
        String quality_level = "";
        PluginImpl instance = new PluginImpl();
        
        instance.setQuality_level(quality_level);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getVersion method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetVersion() {
        System.out.println("getVersion");
        
        PluginImpl instance = new PluginImpl();
        
        String expResult = "";
        String result = instance.getVersion();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setVersion method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetVersion() {
        System.out.println("setVersion");
        
        String version = "";
        PluginImpl instance = new PluginImpl();
        
        instance.setVersion(version);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getNbm_url method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetNbm_url() {
        System.out.println("getNbm_url");
        
        PluginImpl instance = new PluginImpl();
        
        String expResult = "";
        String result = instance.getNbm_url();
        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setNbm_url method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetNbm_url() {
        System.out.println("setNbm_url");
        
        String nbm_url = "";
        PluginImpl instance = new PluginImpl();
        
        instance.setNbm_url(nbm_url);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getCategoryid method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetCategoryid() {
        System.out.println("getCategoryid");
        
//        PluginImpl instance = new PluginImpl();
//
//        String expResult = "";
//        String result = instance.getCategoryid();
//        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setCategoryid method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetCategoryid() {
        System.out.println("setCategoryid");
        
//        String categoryid = "";
//        PluginImpl instance = new PluginImpl();
//
//        instance.setCategoryid(categoryid);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of getOther_categories method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testGetOther_categories() {
        System.out.println("getOther_categories");
        
//        PluginImpl instance = new PluginImpl();
//
//        String expResult = "";
//        String result = instance.getOther_categories();
//        assertEquals(expResult, result);
        
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    /**
     * Test of setOther_categories method, of class org.netbeans.pluginportal.data.PluginImpl.
     */
    public void testSetOther_categories() {
        System.out.println("setOther_categories");
        
//        String other_categories = "";
//        PluginImpl instance = new PluginImpl();
//
//        instance.setOther_categories(other_categories);
//
        // TODO review the generated test code and remove the default call to fail.
        fail("The test case is a prototype.");
    }
    
    public void persist(Object object) {
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            // TODO:
            // em.persist(object);    em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }
    
}
