/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.tree.menu;


import java.util.HashMap;
import javax.swing.*;
import org.netbeans.testspeceditor.ui.actions.NodeAction;
import org.netbeans.testspeceditor.ui.actions.Action;

/**
 *
 * @author  eh103527
 */
public class PopupSupport {
    
    static PopupSupport instance=null;
    
    HashMap<JComponent, PopupMenu> componentsMenus;
    HashMap<NodeAction, JMenuItem> menus;
    
    
     
    public PopupSupport() {
        componentsMenus = new HashMap(4);
        menus = new HashMap(64);
    }
    
    public static PopupSupport getDefault() {
        if (instance == null) {
            instance=new PopupSupport();
        }
        return instance;
    }
    
    public Action[] findAllActions() {
        HashMap<Class<? extends Action>, Action> actions=new HashMap(64);
        for (PopupMenu pm:componentsMenus.values()) {
            Action[] act=pm.getActions();
            if (act == null) continue;
            for (int i = 0; i < act.length; i++) {
                if (act[i] != null) {
                    if (actions.get(act[i].getClass()) == null) {
                        actions.put(act[i].getClass(), act[i]);
                    }
                }
            }
        }
        return actions.values().toArray(new Action[actions.size()]);
    }
    
    public void registerJTree(JTree component) {
        if (componentsMenus.get(component) != null)
            throw new IllegalStateException("Tree popup menu is registered twice for one tree.");
        TreePopupMenu menu = new TreePopupMenu(component);
        component.addMouseListener(menu);
        componentsMenus.put(component, menu);
    }
    
    public void registerMenu(JMenu menu, Action[] actions) {
        MenuPopupMenu pm = new MenuPopupMenu(menu.getPopupMenu(), actions);
        menu.addMenuListener(pm);
        componentsMenus.put(menu, pm);
    }
}
