/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 * 
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 * 
 * 
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 * 
 * Contributor(s):
 * 
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2007 Sun
 * Microsystems, Inc. All Rights Reserved.
 * 
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.testspeceditor.ui.tree.menu;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JPopupMenu;
import javax.swing.JTree;
import org.netbeans.testspeceditor.ui.actions.ActionsManager;
import org.netbeans.testspeceditor.ui.tree.Node;
import org.netbeans.testspeceditor.utils.Utils;

/**
 *
 * @author ehucka
 */
public class TreePopupMenu extends PopupMenu implements MouseListener {
    
    JTree tree = null;
    
     
    public TreePopupMenu(JTree tree) {
        super(new JPopupMenu(), null);
        this.tree = tree;
    }
    
    public void generateMenu() {
        Node[] selected = Utils.getSelectedNodes(tree);
        if (selected != null && selected.length > 0) {
            actions = ActionsManager.getInstance().getActions(selected);
            clear();
            if (actions != null) {
                for (int i = 0; i < actions.length; i++) {
                    menu.add(getMenu(actions[i]));
                }
            }
            activateActions(selected);
        }
    }
    
    public void mouseReleased(java.awt.event.MouseEvent e) {
    }
    
    public void mousePressed(java.awt.event.MouseEvent e) {
    }
    
    public void mouseExited(java.awt.event.MouseEvent e) {
    }
    
    public void mouseEntered(java.awt.event.MouseEvent e) {
    }
    
    public void mouseClicked(java.awt.event.MouseEvent e) {
        if (e.getButton() == MouseEvent.BUTTON3) {
            invokePopup((JTree)(e.getComponent()), e.getX(), e.getY());
        }
    }
    
    public void invokePopup(JTree component, int x, int y) {
        generateMenu();
        
        menu.pack();
        menu.show(component,x,y);
        menu.repaint();
    }
    
}
