/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2008 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */
package org.netbeans.modules.quiz.entities;

import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToOne;
import javax.persistence.Table;

/**
 *
 * @author Jindrich Sedek
 */
@Entity
@Table(name = "WINNERS")
@NamedQueries({@NamedQuery(name = "Winners.findByQuiz", query = "SELECT w FROM Winners w WHERE w.quiz = :quiz")})
public class Winners implements Serializable, Comparable<Winners> {

    private static final long serialVersionUID = 1L;
    @Id
    @Column(name = "QUIZ", nullable = false)
    private Integer quizId;
    @JoinColumn(name = "NBUSER", referencedColumnName = "ID")
    @ManyToOne
    private NbUser nbuser;
    @JoinColumn(name = "QUIZ", referencedColumnName = "ID", insertable = false, updatable = false)
    @OneToOne
    private Quiz quiz;

    public Winners() {
    }

    public Winners(Quiz quiz, NbUser user) {
        this.nbuser = user;
        this.quizId = quiz.getId();
        this.quiz = quiz;
    }

    public Integer getQuizId() {
        return quizId;
    }

    public void setQuizId(Integer quiz) {
        this.quizId = quiz;
    }

    public NbUser getNbuser() {
        return nbuser;
    }

    public void setNbuser(NbUser nbuser) {
        this.nbuser = nbuser;
    }

    public Quiz getQuiz() {
        return quiz;
    }

    public void setQuiz(Quiz quiz1) {
        this.quizId = quiz1.getId();
        this.quiz = quiz1;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (quizId != null ? quizId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Winners)) {
            return false;
        }
        Winners other = (Winners) object;
        if ((this.quizId == null && other.quizId != null) || (this.quizId != null && !this.quizId.equals(other.quizId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "org.netbeans.modules.quiz.entities.Winners[quiz=" + quizId + "]";
    }

    public int compareTo(Winners w) {
        return this.quiz.compareTo(w.quiz);
    }
}
