/*
                    Sun Public License Notice
 
The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/
 
The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.
 
Contributor(s): Petr Slegr.
 */

package org.netbeans.modules.regsup.auted;

import java.beans.PropertyChangeListener;
import javax.swing.event.EventListenerList;

/**
 *
 * @author Petr Slegr
 * @version 09.05.02
 */
public class NodeGeometryFactory implements GeometryFactory {
    
    /**
     */
    public ElementGeometry create (VisualAutomatonElement element) {
        if (! (element instanceof VisualAutomatonNode)) {
            throw new IllegalArgumentException ("VisualAutomatonNode required: " + element);
        }
        VisualAutomatonNode node = (VisualAutomatonNode) element;
        return new NodeGeometry (node);
    }
    
}
