/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.auted.actions;

import org.netbeans.modules.regsup.auted.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.JMenuItem;
import org.netbeans.modules.regsup.util.Util;
import org.openide.util.NbBundle;

/**
 *
 * @author  Petr Slegr
 * @version 23.06.01/2
 */
public class ToggleStartingNodeAction extends ElementAction {

    /*
    private static final String UN_MARK_NAME = new String ("Unmark starting");
    
    private static final String MARK_NAME = new String ("Mark starting");
    
    private String actionName;
     */
    
    public void performAction (VisualAutomatonElement[] selected) {
        for (int i = 0; i < selected.length; i++) {
            VisualAutomatonNode node = (VisualAutomatonNode) selected[i];
            node.setStarting (! node.isStarting ());
        }
    }
    
    /** Enabled both on nodes and containers.
     */
    public boolean isEnabled (VisualAutomatonElement[] selected) {
        boolean b1 = selected.length > 0;
        boolean b2 = Util.areAllInstanceOf (selected, VisualAutomatonNode.class);
        boolean b3 = ! Util.containsTopLevelContainer (selected);
        return b1 && b2 && b3;
    }
  
    public String getName () {
        //return NbBundle.getMessage (this.getClass (), "CTL_TOGGLE_STARTING_NODE_ACTION");
        return "Toggle Starting";
    }
    
}
