/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.debug;

import org.netbeans.modules.regsup.auted.*;


/** System (hidden) breakpoint used in StepOver action.
 *
 * @author  Petr Slegr
 * @version 07.04.02
 */
// !!!??? what about to subclass NodeBreakpoint instead AutomatonBreakpoint ???
class OverContainerBreakpoint extends AutomatonBreakpoint {

    protected VisualAutomatonContainer container;
    
    public OverContainerBreakpoint (VisualAutomatonContainer container) {
        this.container = container;
        setHidden (true);
    }

    public boolean applies (RexDebuggerState state) {
        return state.containsClosedContainer (container);
    }
    
    public String toString () {
        return super.toString () + " on container: " + container;
    }
    
    /** Return element of automaton this breakpoint is on or null (e.g. for
     * some more complicated multi-element breakpoints).
     */
    public VisualAutomatonElement getElement () {
        return container;
    }
    
}
