/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.ide;

import java.awt.Image;
import java.beans.*;

import org.openide.TopManager;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;

public class RegsupDataLoaderBeanInfo extends SimpleBeanInfo {
    
    // If you have additional properties:
    /*
    public PropertyDescriptor[] getPropertyDescriptors () {
        try {
            PropertyDescriptor myProp = new PropertyDescriptor ("myProp", RegsupDataLoader.class);
            myProp.setDisplayName (NbBundle.getMessage (RegsupDataLoaderBeanInfo.class, "PROP_myProp"));
            myProp.setShortDescription (NbBundle.getMessage (RegsupDataLoaderBeanInfo.class, "HINT_myProp"));
            return new PropertyDescriptor[] { myProp };
        } catch (IntrospectionException ie) {
            TopManager.getDefault ().getErrorManager ().notify (ie);
            return null;
        }
    }
     */
    
    public BeanInfo[] getAdditionalBeanInfo () {
        try {
            // I.e. MultiFileLoader.class or UniFileLoader.class.
            return new BeanInfo[] { Introspector.getBeanInfo (RegsupDataLoader.class.getSuperclass ()) };
        } catch (IntrospectionException ie) {
            TopManager.getDefault ().getErrorManager ().notify (ie);
            return null;
        }
    }
    
    public Image getIcon (int type) {
        if (type == BeanInfo.ICON_COLOR_16x16 || type == BeanInfo.ICON_MONO_16x16) {
            return Utilities.loadImage ("__PACKAGE_NAME_SLASHES$DataLoaderBeanInfo$DataIcon$MyIcon__.gif");
        } else {
            return Utilities.loadImage ("__PACKAGE_NAME_SLASHES$DataLoaderBeanInfo$DataIcon32$MyIcon32__.gif");
        }
    }
    
}
