/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.logic;

import java.util.Set;
import java.util.HashSet;
import java.util.Iterator;

public class RexClosureElement extends RexElement {
    
    protected RexElement elem;
    
    /**
     */
    public RexClosureElement (RexElement elem) {
        //if (elem instanceof RexEmptyElement)
        //  throw new IllegalArgumentException (elem.toString ());
        this.elem = elem;
    }
    
    /**
     * @return number of TOP LEVEL elements
     */
    public int size () {
        if (elem instanceof RexEmptyElement)
            return 0;
        return 1;
    }
    
    public String toString () {
        if (elem.size () == 0)
            // !!??
            return new String ();
        StringBuffer buf = new StringBuffer ();    
        boolean par = true;
        if (elem.size () == 1)
            par = false;
        if (par)
            buf.append ('(');   // !! const
        buf.append (elem.toString ());
        if (par)
            buf.append (')');   // !! const
        buf.append ('*');   // !! const
        return buf.toString ();
    }

    public Object clone () {
        return new RexClosureElement ((RexElement) elem.clone ());
    }
}
