/*
                    Sun Public License Notice

The contents of this file are subject to the Sun Public License Version
1.0 (the "License"). You may not use this file except in compliance with
the License. A copy of the License is available at http://www.sun.com/

The Original Code is the Regsup module.
The Initial Developer of the Original Code is Petr Slegr.
Portions created by Petr Slegr are Copyright (C) 2002.
All Rights Reserved.

Contributor(s): Petr Slegr.
*/

package org.netbeans.modules.regsup.logic;

import java.util.Set;
import java.util.HashSet;
import java.util.Iterator;
import java.util.ArrayList;

public class RexConcatElement extends RexElement {
    
    protected ArrayList concats;
    
    public RexConcatElement () {
        concats = new ArrayList ();
    }
    
    
    public RexConcatElement (RexElement el) {
        this ();
        add (el);
    }
    
    public RexConcatElement (RexElement elem1, RexElement elem2) {
        this (elem1);
        add (elem2);
    }
    
    public RexConcatElement (String string) {
        this ();
        for (int i=0; i<string.length (); i++) {
            char c = string.charAt (i);
            add (new RexCharElement (c));
        }
    }
    
    public void add (RexElement el) {
        if (el == null) {
            throw new IllegalArgumentException ("el cannot be null");
        }
        if (el instanceof RexEmptyElement) {
            // have no sense to add
            return;
        }
        concats.add (el);
    }
    
    public String toString () {
        StringBuffer buf = new StringBuffer ();
        //Iterator it = concats.iterator ();
        //while (it.hasNext ()) {
        for (int i=0; i < concats.size (); i++) {
            //Object el = it.next ();
            buf.append (concats.get (i).toString ());
        }
        return buf.toString ();
    }
    
    /** Makes a deep copy
     */
    public Object clone () {
        RexConcatElement elem = new RexConcatElement ();
        Iterator it = concats.iterator ();
        while (it.hasNext ()) {
            RexElement next = (RexElement) it.next ();
            RexElement clone = (RexElement) next.clone ();
            elem.add (clone);
        }
        return elem;
    }
   
    public int size () {
        return concats.size ();
    }
}
