/*
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
*
* Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
*
* The contents of this file are subject to the terms of either the GNU
* General Public License Version 2 only ("GPL") or the Common
* Development and Distribution License("CDDL") (collectively, the
* "License"). You may not use this file except in compliance with the
* License. You can obtain a copy of the License at
* http://www.netbeans.org/cddl-gplv2.html
* or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
* specific language governing permissions and limitations under the
* License.  When distributing the software, include this License Header
* Notice in each file and include the License file at
* nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
* particular file as subject to the "Classpath" exception as provided
* by Sun in the GPL Version 2 section of the License file that
* accompanied this code. If applicable, add the following below the
* License Header, with the fields enclosed by brackets [] replaced by
* your own identifying information:
* "Portions Copyrighted [year] [name of copyright owner]"
*
* Contributor(s):
*
* The Original Software is NetBeans. The Initial Developer of the Original
* Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
* Microsystems, Inc. All Rights Reserved.
*
* If you wish your version of this file to be governed by only the CDDL
* or only the GPL Version 2, indicate your decision by adding
* "[Contributor] elects to include this software in this distribution
* under the [CDDL or GPL Version 2] license." If you do not indicate a
* single choice of license, a recipient has the option to distribute
* your version of this file under either the CDDL, the GPL Version 2 or
* to extend the choice of license to its licensees as provided above.
* However, if you add GPL Version 2 code and therefore, elected the GPL
* Version 2 license, then the option applies only if the new code is
* made subject to such option by the copyright holder.
*/

package org.netbeans.modules.vcs.cmdline;

import javax.swing.event.*;
import javax.swing.table.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

import org.openide.util.*;
import org.openide.*;

import org.netbeans.modules.vcscore.VcsConfigVariable;
import org.netbeans.modules.vcscore.util.*;
//import org.netbeans.modules.vcscore.cmdline.*;
import org.netbeans.modules.vcscore.commands.*;
//import org.netbeans.modules.vcscore.commands.CommandListener;
//import org.netbeans.modules.vcscore.commands.VcsCommandExecutor;

/** This panel attempts to get the list of modules from the server.
 * Then lets the user pick one or more modules for checkout and issues
 * the checkout command.
 * @author mkleint
 * @version 1.0
 */
public class Cust3CheckoutPanel extends javax.swing.JPanel implements CvsCustomPanel, CommandDataOutputListener {
    private ArrayList listeners;
    private javax.swing.ButtonGroup bg;

    private CvsFileSystem fs;
    private org.netbeans.modules.vcscore.commands.CommandsPool cPool;
    private NewCvsCustomizer customizer;
    private Vector modules = null;
    private String[] modulesSelected;
    private boolean validSelection = false;
    private boolean isDone;
    private StringBuffer outputBuffer = null;
    private boolean completeIsDone;
    private CompleteStatusOutput completeList;
    private VcsCommandExecutor cModule;
    private VcsCommandExecutor sModule;


    static final long serialVersionUID = 3353171355503637057L;

    /** Creates new form Cust3CheckoutModule */
    public Cust3CheckoutPanel() {
        isDone = false;
        initComponents ();   
        bg = new javax.swing.ButtonGroup ();
        bg.add (rbCheckout);
        bg.add (rbCheckModule);
        rbCheckModule.setSelected(true);
        buttonsChanged();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        statusLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tblModules = new javax.swing.JTable();
        rbCheckout = new javax.swing.JRadioButton();
        rbCheckModule = new javax.swing.JRadioButton();
        lbFreeForm = new javax.swing.JLabel();
        txFreeForm = new javax.swing.JTextField();
        setLayout(new java.awt.GridBagLayout());
        java.awt.GridBagConstraints gridBagConstraints1;

        statusLabel.setText("kuk");

        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 4;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.insets = new java.awt.Insets(8, 7, 0, 8);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints1.weightx = 1.0;
        add(statusLabel, gridBagConstraints1);


        jScrollPane1.setPreferredSize(new java.awt.Dimension(200, 200));

        tblModules.setShowVerticalLines(false);
        tblModules.setPreferredScrollableViewportSize(new java.awt.Dimension(300, 200));
        tblModules.setShowHorizontalLines(false);
        jScrollPane1.setViewportView(tblModules);


        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 5;
        gridBagConstraints1.gridwidth = 2;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints1.insets = new java.awt.Insets(8, 8, 8, 8);
        gridBagConstraints1.weightx = 1.0;
        gridBagConstraints1.weighty = 1.0;
        add(jScrollPane1, gridBagConstraints1);


        rbCheckout.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("NewCvsCustomizer.rbCheckout.text"));
        rbCheckout.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbCheckoutActionPerformed(evt);
            }
        }
        );

        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.insets = new java.awt.Insets(12, 19, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(rbCheckout, gridBagConstraints1);


        rbCheckModule.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("NewCvsCustomizer.rbCheckModule.text"));
        rbCheckModule.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rbCheckModuleActionPerformed(evt);
            }
        }
        );

        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 3;
        gridBagConstraints1.insets = new java.awt.Insets(17, 19, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(rbCheckModule, gridBagConstraints1);


        lbFreeForm.setText(java.util.ResourceBundle.getBundle("org/netbeans/modules/vcs/cmdline/Bundle").getString("NewCvsCustomizer.jLabel1.text"));

        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 0;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.ipadx = 48;
        gridBagConstraints1.insets = new java.awt.Insets(0, 8, 0, 0);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.EAST;
        add(lbFreeForm, gridBagConstraints1);



        gridBagConstraints1 = new java.awt.GridBagConstraints();
        gridBagConstraints1.gridx = 1;
        gridBagConstraints1.gridy = 1;
        gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints1.ipadx = 87;
        gridBagConstraints1.insets = new java.awt.Insets(0, 0, 0, 8);
        gridBagConstraints1.anchor = java.awt.GridBagConstraints.WEST;
        add(txFreeForm, gridBagConstraints1);

    }//GEN-END:initComponents

    private void rbCheckModuleActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbCheckModuleActionPerformed
// Add your handling code here:
        buttonsChanged();
    }//GEN-LAST:event_rbCheckModuleActionPerformed

    private void rbCheckoutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rbCheckoutActionPerformed
// Add your handling code here:
        buttonsChanged();
    }//GEN-LAST:event_rbCheckoutActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel statusLabel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable tblModules;
    private javax.swing.JRadioButton rbCheckout;
    private javax.swing.JRadioButton rbCheckModule;
    private javax.swing.JLabel lbFreeForm;
    private javax.swing.JTextField txFreeForm;
    // End of variables declaration//GEN-END:variables

    private void buttonsChanged() {
        if (rbCheckout.isSelected()) {
            lbFreeForm.setEnabled(true);
            txFreeForm.setEnabled(true);
            tblModules.setEnabled(false);
            statusLabel.setEnabled(false);
        }
        else {
            lbFreeForm.setEnabled(false);
            txFreeForm.setEnabled(false);
            tblModules.setEnabled(true);
            statusLabel.setEnabled(true);
        }
    }

    public boolean showDialog() {
        setVisible(true);
        return validSelection;
    }


    private void waitingForModules() {
        statusLabel.setText(org.openide.util.NbBundle.getBundle(NewCvsCustomizer.class).getString("NewCvsCustomizer.waitingForModules"));
    }

    private void setModules(Vector modules) {
        this.modules = modules;
//if (waitDlg != null) waitDlg.setVisible(false);
        if (modules == null || modules.size() == 0) {
            javax.swing.SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    NotifyDescriptor nd = new NotifyDescriptor.Message (org.openide.util.NbBundle.getBundle(NewCvsCustomizer.class).getString("NewCvsCustomizer.noModules"));
                    TopManager.getDefault ().notify (nd);
                }
            });
//  rbCheckoutModule.setEnabled(false);
//   closeDialog(null);
        } else {
            statusLabel.setText(org.openide.util.NbBundle.getBundle(NewCvsCustomizer.class).getString("NewCvsCustomizer.modulesLoaded"));
            Vector columns = new Vector();
            columns.add(org.openide.util.NbBundle.getBundle(NewCvsCustomizer.class).getString("NewCvsCustomizer.columnModule"));
            columns.add(org.openide.util.NbBundle.getBundle(NewCvsCustomizer.class).getString("NewCvsCustomizer.columnStatus"));
            DefaultTableModel model = new MyDefaultTableModel(modules, columns);
            tblModules.setModel(model);
        }
    }

    private String[] getSelection() {
        if (tblModules.getSelectedRowCount() == 0) {return null;}
        int[] select = tblModules.getSelectedRows();
        TableModel model = tblModules.getModel();
        Vector selStr = new Vector();
        for (int ind = 0; ind < select.length; ind++) {
            String mod = (String)model.getValueAt(select[ind], 0);
            selStr.add(mod);
        }
        String[] modulesStrs = (String[]) selStr.toArray(new String[0]);
        return modulesStrs;
    }



    public String getName() {
        return org.openide.util.NbBundle.getBundle(NewCvsCustomizer.class).getString("NewCvsCustomizer.checkoutDialogLabel");
    }

    /** last panel check.
     * @return true if last else false.
     */
    public boolean isLast() {
        return false;
    }

    public int getNext() {
        return 4;
    }


    /** Add a listener to changes of the panel's validity.
     * @param l the listener to add
     * @see #isValid
     */
    private synchronized void addChangeListener(ChangeListener l) {
        if (listeners == null) {
            listeners = new ArrayList ();
        }
        listeners.add (l);
    }

    /** Remove a listener to changes of the panel's validity.
     * @param l the listener to remove
     */
    private synchronized void removeChangeListener(ChangeListener l) {
        if (listeners != null) {
            listeners.remove (l);
        }
    }

    private void fireChangeState() {
        ArrayList list;
        synchronized (this) {
            if (this.listeners == null)
                return;
            list = (ArrayList) this.listeners.clone();
        }
        ChangeEvent event = new ChangeEvent (this);
        for (int i=0; i<list.size(); i++)
            ((ChangeListener)list.get (i)).stateChanged (event);
    }


    public void killAllRunning() {
        if (cModule != null) cPool.kill(cModule);
        if (sModule != null) cPool.kill(sModule);
    }

    private void doSelectModule() {
        outputBuffer = new StringBuffer();
        //VcsConfigVariable var = (VcsConfigVariable) fs.getVariablesByName().get ("MODULE_NAME");
        //if (var == null) return;
        VcsCommand coModule = fs.getCommand("CUSTOMIZER");
        //OutputContainer container = new OutputContainer(g("MSG_VariableSelector"));
        //final ExecuteCommand es = new ExecuteCommand(fs, coModule, fs.getVariablesAsHashtable());
        final VcsCommandExecutor vce = fs.getVcsFactory().getCommandExecutor(coModule, fs.getVariablesAsHashtable());
        //es.setErrorNoRegexListener(container);
        //es.setOutputNoRegexListener(container);
        //es.setErrorContainer(container);
        //es.setOutputListener(this);
        vce.addDataOutputListener(this);
        sModule = vce;
        doGetAllModules();
        waitingForModules();
//javax.swing.SwingUtilities.invokeLater(new Runnable() {
//public void run() {
        new Thread ("CVS-ModuleSelection") {
            public void run() {
                //es.start();
                cPool.startExecutor(vce);
                try {
                    cPool.waitToFinish(vce);
                } catch (InterruptedException iexc) {
                    cPool.kill(vce);
                    return ;
                }
                /*
                try {
                es.join();
                sModule = null;
                } catch (InterruptedException e) {
                sModule = null;
                return;
                }
                */
                Vector vect = getModules();
                try {
                    while (!completeIsDone) {
                        Thread.sleep(1000);
                    }
                } catch (InterruptedException ei) {
                    return;
                }
                D("Waiting done.");
                statusLabel.setText(org.openide.util.NbBundle.getBundle(NewCvsCustomizer.class).getString("NewCvsCustomizer.modulesLoaded"));
                Vector columns = new Vector();
                completeList.insertDifferent(vect);
                columns.add(org.openide.util.NbBundle.getBundle(NewCvsCustomizer.class).getString("NewCvsCustomizer.columnModule"));
                columns.add(org.openide.util.NbBundle.getBundle(NewCvsCustomizer.class).getString("NewCvsCustomizer.columnStatus"));
                DefaultTableModel model = new MyDefaultTableModel(vect, columns);
                tblModules.setModel(model);
            }
        }.start();
    }

    private void doCheckoutModule(String moduleList) {
        //VcsConfigVariable var = (VcsConfigVariable) fs.getVariablesByName().get ("MODULE_NAME");
        //if (var == null) return;
        //var.setValue(moduleList);
        VcsCommand coModule = fs.getCommand("CHECKOUT_MODULES");
        //OutputContainer container = new OutputContainer(g("MSG_VariableSelector"));
        //final ExecuteCommand es = new ExecuteCommand(fs, coModule,
        //                                             fs.getVariablesAsHashtable());
        Hashtable vars = fs.getVariablesAsHashtable();
        vars.put("MODULE_NAME", moduleList);
        final VcsCommandExecutor vce = fs.getVcsFactory().getCommandExecutor(coModule, vars);
        /*
        es.setErrorNoRegexListener(container);
        es.setOutputNoRegexListener(container);
        es.setErrorContainer(container);
        */
        customizer.setWait(true);
        cPool.addCommandListener(new CommandListener() {
            public void commandStarted(VcsCommandExecutor vce2) {
            }

            public void commandDone(VcsCommandExecutor vceDone) {
                if (vce == vceDone) {
                    customizer.setWait(false);
                    cPool.removeCommandListener(this);
                }
            }
        });
        cPool.startExecutor(vce);
//javax.swing.SwingUtilities.invokeLater(new Runnable() {
//public void run() {
        /*
        new Thread ("CVS-ModuleCheckout") {
        public void run() {
        //es.start();
        cPool.startExecutor(vce);
        cPool.waitToFinish(vce);
        customizer.setWait(false);
        /*
        try {
        es.join();
        customizer.setWait(false);
        } catch (InterruptedException e) {
        customizer.setWait(false);
        return;
        }

        }
        }.start();
        */
    }

    private void doGetAllModules() {
        completeIsDone = false;
        VcsCommand coModule = fs.getCommand("GET_MODULE_NAME");
        //OutputContainer container = new OutputContainer(g("MSG_VariableSelector"));
        //final ExecuteCommand es = new ExecuteCommand(fs, coModule,
        //                                             fs.getVariablesAsHashtable());
        final VcsCommandExecutor vce = fs.getVcsFactory().getCommandExecutor(coModule, fs.getVariablesAsHashtable());
        //es.setErrorNoRegexListener(container);
        //es.setOutputNoRegexListener(container);
        //es.setErrorContainer(container);
        completeList = new CompleteStatusOutput();
        //es.setOutputListener(completeList);
        vce.addDataOutputListener(completeList);
        customizer.setWait(true);
        cModule = vce;
        cPool.addCommandListener(new CommandListener() {
            public void commandStarted(VcsCommandExecutor vce2) {
            }

            public void commandDone(VcsCommandExecutor vceDone) {
                if (vce == vceDone) {
                    cModule = null;
                    completeIsDone = true;
                    cPool.removeCommandListener(this);
                }
            }
        });
        cPool.startExecutor(vce);
        D("Get all ready");
        /*
        new Thread ("CVS-GetAllModules") {
        public void run() {
        cPool.startExecutor(vce);
        cPool.waitToFinish(vce);
        cModule = null;
        completeIsDone = true;
        /*
        es.start();
        try {
        es.join();
        cModule = null;
        completeIsDone = true;
        } catch (InterruptedException e) {
        completeIsDone=true;
        return;
        }
        *
        }
        }.start();
        */
    }



    /** method from the NoRegExpListener.
     * reads al output of the checkout -s command.
     * @param elements lines.
     */
    public void outputData(String[] elements) {
        if (elements[0].length() > 0 && elements[0].charAt(0) != '#')
            outputBuffer.append(elements[0]+"\n");
    }

    private Vector getModules() {
        Vector modules = new Vector();
        String output = outputBuffer.toString();
//MK rewrite to add status of the modules..
        String line;
        int index = 0;
        StringBuffer module;
        int addedCount = 0;
        StringTokenizer token = new StringTokenizer(output, "\n", false);
        while (token.hasMoreTokens()) {
            Vector row = new Vector();
            line = token.nextToken();
            if (line.startsWith(" ") || line.startsWith("\t")) continue; // it's not a line with module name
            line = line.replace('\t',' ');
            StringTokenizer lineTok = new StringTokenizer(line, " ", false);
            if (lineTok.countTokens() < 2) continue;
            String prvni = lineTok.nextToken();
            row.add(prvni);
            row.add(lineTok.nextToken());
            modules.add(row);
        }
        return modules;
    }

    private String[] getTableSelection() {
        if (tblModules.getSelectedRowCount() == 0) {return null;}
        int[] select = tblModules.getSelectedRows();
        TableModel model = tblModules.getModel();
        Vector selStr = new Vector();
        for (int ind = 0; ind < select.length; ind++) {
            String mod = (String)model.getValueAt(select[ind], 0);
            selStr.add(mod);
        }
        String[] modulesStrs = (String[]) selStr.toArray(new String[0]);
        return modulesStrs;
    }

    String g(String s) {
        return NbBundle.getBundle
                ("org.netbeans.modules.vcs.cmdline.Bundle").getString (s);
    }

    private void D(String mess) {
        //  System.out.println("Cust3:" + mess);
    }

    class MyDefaultTableModel extends DefaultTableModel {

        static final long serialVersionUID = -2588927436289647645L;

        /** Inner class which makes all the cells in the Module select table not-editable.
         * @param data vector of data in the table.
         * @param columns Vector describing current columns.
         */
        public MyDefaultTableModel (Vector data, Vector columns) {
            super(data, columns);
        }

        /** sets all cels un-editable.
         * @return tru if editable, othewise false.
         * @param row row in the table.
         * @param column column in the table.
         */
        public boolean isCellEditable(int row, int column) {
            return false;
        }

    }

    private final class CompleteStatusOutput implements CommandDataOutputListener {
        private LinkedList statuses;

        public CompleteStatusOutput() {
            statuses = new LinkedList();
        }

        public void removeFromList(String name) {
            statuses.remove(name);
        }

        public void  insertDifferent(Vector modules) {
            Iterator parIter = modules.iterator();
            while(parIter.hasNext()) { // first remove all that are in the list with statuses
                Vector row = (Vector)parIter.next();
                removeFromList((String)row.get(0));
            }
            Iterator it = statuses.iterator();
            while (it.hasNext()) {
                Vector row = new Vector();
                String str = (String)it.next();
                D("in -c list:" + str);
                row.add(str);
                row.add("");
                modules.add(row);
            }
        }

        /** method from the NoRegExpListener.
         * reads al output of the checkout -c command.
         * @param elements lines.
         */
        public void outputData(String[] elements) {
            if (elements[0].length() > 0 && elements[0].charAt(0) != '#') {
                String start = elements[0];
                if (start == null) return;
                if (!start.startsWith(" ")) {
                    int index = start.indexOf(' ');
                    if (index > 0) {
                        String name = start.substring(0,index);
                        statuses.add(name);
                    }
                }
            }
        }

    }


    public static class Panel implements WizardDescriptor.Panel {

        private String name;
        private Cust3CheckoutPanel panel;

        public Panel (String name) {
            this.name = name;
        }

        /** Get the component displayed in this panel.
         * @return the component
         */
        public java.awt.Component getComponent() {
            if (this.panel == null) {
                this.panel = new Cust3CheckoutPanel ();
                if (this.name != null)
                    this.panel.setName (this.name);
            }
            return this.panel;
        }
        /** Help for this panel.
         * When the panel is active, this is used as the help for the wizard dialog.
         * @return the help or <code>null</code> if no help is supplied
         */
        public HelpCtx getHelp() {
            return HelpCtx.DEFAULT_HELP;
        }

        /** Provides the wizard panel with the current data--either
         * the default data or already-modified settings, if the user used the previous and/or next buttons.
         * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
         * @param settings the object representing wizard panel state, as originally supplied to {@link WizardDescriptor#WizardDescriptor(WizardDescriptor.Iterator,Object)}
         */
        public void readSettings(Object settings) {
            if (settings instanceof NewCvsCustomizer) {
                Cust3CheckoutPanel p = (Cust3CheckoutPanel) this.getComponent();
                p.customizer = (NewCvsCustomizer)settings;
                p.fs = p.customizer.getFileSystem();
                if (p.fs != null) {
                    p.cPool = p.fs.getCommandsPool();
                    p.customizer.setChanges();
                    p.doSelectModule();
                    p.customizer.unSetChanges();
                }
            }
        }

        /** Provides the wizard panel with the opportunity to update the
         * settings with its current customized state.
         * Rather than updating its settings with every change in the GUI, it should collect them,
         * and then only save them when requested to by this method.
         * Also, the original settings passed to {@link #readSettings} should not be modified (mutated);
         * rather, the (copy) passed in here should be mutated according to the collected changes.
         * This method can be called multiple times on one instance of <code>WizardDescriptor.Panel</code>.
         * @param settings the object representing a settings of the wizard
         */
        public void storeSettings(Object settings) {
            if (settings instanceof NewCvsCustomizer) {
                Cust3CheckoutPanel p = (Cust3CheckoutPanel) this.getComponent();
                p.customizer = (NewCvsCustomizer)settings;
                String list = "";
                p.fs = p.customizer.getFileSystem();
                String[] sels = p.getTableSelection();
                if (sels != null && p.rbCheckModule.isSelected()) {
                    if (sels[0].equals("")) {
                        p.customizer.setWait(false);
                        return;
                    }
                    p.modulesSelected = sels;
                    list = VcsUtilities.arrayToQuotedString(p.modulesSelected, p.customizer.useUnixShell);
                    p.customizer.setChanges();
                    p.doCheckoutModule(list);
                    p.customizer.unSetChanges();
                    return;
                }
                if (p.rbCheckout.isSelected()) {
                    if (!p.txFreeForm.getText().equals(""))  {
                        p.modulesSelected = new String[1];
                        p.modulesSelected[0] = p.txFreeForm.getText();
                        list = VcsUtilities.arrayToQuotedString(p.modulesSelected, p.customizer.useUnixShell);
                        p.customizer.setChanges();
                        p.doCheckoutModule(list);
                        p.customizer.unSetChanges();
                        return;
                    }
                }
                p.customizer.setWait(false);
            }
        }
        /** Test whether the panel is finished and it is safe to proceed to the next one.
         * If the panel is valid, the "Next" (or "Finish") button will be enabled.
         * @return <code>true</code> if the user has entered satisfactory information
         */
        public boolean isValid() {
            return true;
        }


        public void addChangeListener (ChangeListener l) {
            ((Cust3CheckoutPanel)this.getComponent()).addChangeListener (l);
        }

        public void removeChangeListener (ChangeListener l) {
            ((Cust3CheckoutPanel)this.getComponent()).removeChangeListener (l);
        }

    }

}
