/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 1997-2007 Sun Microsystems, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common
 * Development and Distribution License("CDDL") (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.netbeans.org/cddl-gplv2.html
 * or nbbuild/licenses/CDDL-GPL-2-CP. See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * Notice in each file and include the License file at
 * nbbuild/licenses/CDDL-GPL-2-CP.  Sun designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Sun in the GPL Version 2 section of the License file that
 * accompanied this code. If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * Contributor(s):
 *
 * The Original Software is NetBeans. The Initial Developer of the Original
 * Software is Sun Microsystems, Inc. Portions Copyright 1997-2006 Sun
 * Microsystems, Inc. All Rights Reserved.
 *
 * If you wish your version of this file to be governed by only the CDDL
 * or only the GPL Version 2, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [CDDL or GPL Version 2] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under either the CDDL, the GPL Version 2 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 2 code and therefore, elected the GPL
 * Version 2 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 */

package org.netbeans.modules.xtest;

import java.io.File;
import javax.swing.JPanel;
import org.netbeans.api.project.Project;
import org.netbeans.api.project.ProjectUtils;

import org.openide.WizardDescriptor;
import org.openide.filesystems.FileUtil;
import org.openide.util.HelpCtx;
import org.openide.util.NbBundle;

public class XTestWizardPanelVisual extends JPanel implements HelpCtx.Provider {

    /** Creates new form PanelInitProject */
    public XTestWizardPanelVisual(Project project) {
        initComponents();
        projectTextField.setText(ProjectUtils.getInformation(project).getName());
        String testPath = FileUtil.getFileDisplayName(project.getProjectDirectory())+File.separator+"test"+File.separator;
        xtestScriptTextField.setText(testPath+"build.xml"); // NOI18N
        unitScriptTextField.setText(testPath+"build-unit.xml"); //NOI18N
        unitCfgTextField.setText(testPath+"cfg-unit.xml"); //NOI18N
        functionalScriptTextField.setText(testPath+"build-qa-functional.xml"); //NOI18N
        functionalCfgTextField.setText(testPath+"cfg-qa-functional.xml"); //NOI18N
        this.getAccessibleContext().setAccessibleDescription(NbBundle.getMessage(XTestWizardPanelVisual.class, "ACS_InfoPanel_A11YDesc"));  // NOI18N
        // Provide a name in the title bar.
        setName(NbBundle.getMessage(XTestWizardPanelVisual.class, "LBL_InfoPanel_FilesToBeCreated")); //NOI18N
    }


    boolean valid(WizardDescriptor wizardDescriptor) {
        return true;
    }

    void read (WizardDescriptor d) {
    }

    void store(WizardDescriptor d) {
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        projectLabel = new javax.swing.JLabel();
        projectTextField = new javax.swing.JTextField();
        xtestScriptLabel = new javax.swing.JLabel();
        xtestScriptTextField = new javax.swing.JTextField();
        unitScriptLabel = new javax.swing.JLabel();
        unitScriptTextField = new javax.swing.JTextField();
        unitCfgLabel = new javax.swing.JLabel();
        unitCfgTextField = new javax.swing.JTextField();
        functionalScriptLabel = new javax.swing.JLabel();
        functionalScriptTextField = new javax.swing.JTextField();
        functionalCfgLabel = new javax.swing.JLabel();
        functionalCfgTextField = new javax.swing.JTextField();
        jSeparator1 = new javax.swing.JSeparator();
        bottomPlaceholder = new javax.swing.JPanel();

        setLayout(new java.awt.GridBagLayout());

        setPreferredSize(new java.awt.Dimension(500, 200));
        setRequestFocusEnabled(false);
        projectLabel.setLabelFor(projectTextField);
        projectLabel.setText(org.openide.util.NbBundle.getBundle(XTestWizardPanelVisual.class).getString("LBL_InfoPanel_Project"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 12, 0);
        add(projectLabel, gridBagConstraints);

        projectTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 12, 0);
        add(projectTextField, gridBagConstraints);
        projectTextField.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getBundle(XTestWizardPanelVisual.class).getString("ACS_InfoPanel_Project"));

        xtestScriptLabel.setLabelFor(xtestScriptTextField);
        xtestScriptLabel.setText(org.openide.util.NbBundle.getBundle(XTestWizardPanelVisual.class).getString("LBL_InfoPanel_XTest"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 6, 0);
        add(xtestScriptLabel, gridBagConstraints);

        xtestScriptTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 6, 0);
        add(xtestScriptTextField, gridBagConstraints);
        xtestScriptTextField.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getBundle(XTestWizardPanelVisual.class).getString("ACS_InfoPanel_XTest"));

        unitScriptLabel.setLabelFor(unitScriptTextField);
        unitScriptLabel.setText(org.openide.util.NbBundle.getBundle(XTestWizardPanelVisual.class).getString("LBL_InfoPanel_XTest_Unit"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 6, 0);
        add(unitScriptLabel, gridBagConstraints);

        unitScriptTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 6, 0);
        add(unitScriptTextField, gridBagConstraints);
        unitScriptTextField.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getBundle(XTestWizardPanelVisual.class).getString("ACS_InfoPanel_XTest_Unit"));

        unitCfgLabel.setLabelFor(unitCfgTextField);
        unitCfgLabel.setText(org.openide.util.NbBundle.getBundle(XTestWizardPanelVisual.class).getString("LBL_InfoPanel_XTest_Unit_CFG"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 6, 0);
        add(unitCfgLabel, gridBagConstraints);

        unitCfgTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 6, 0);
        add(unitCfgTextField, gridBagConstraints);
        unitCfgTextField.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getBundle(XTestWizardPanelVisual.class).getString("ACS_InfoPanel_XTest_Unit_CFG"));

        functionalScriptLabel.setLabelFor(functionalScriptTextField);
        functionalScriptLabel.setText(org.openide.util.NbBundle.getBundle(XTestWizardPanelVisual.class).getString("LBL_InfoPanel_XTest_Functional"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 6, 0);
        add(functionalScriptLabel, gridBagConstraints);

        functionalScriptTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 6, 0);
        add(functionalScriptTextField, gridBagConstraints);
        functionalScriptTextField.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getBundle(XTestWizardPanelVisual.class).getString("ACS_InfoPanel_XTest_Functional"));

        functionalCfgLabel.setLabelFor(functionalCfgTextField);
        functionalCfgLabel.setText(org.openide.util.NbBundle.getBundle(XTestWizardPanelVisual.class).getString("LBL_InfoPanel_XTest_Functional_CFG"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 6, 0);
        add(functionalCfgLabel, gridBagConstraints);

        functionalCfgTextField.setEditable(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 6, 0);
        add(functionalCfgTextField, gridBagConstraints);
        functionalCfgTextField.getAccessibleContext().setAccessibleDescription(org.openide.util.NbBundle.getBundle(XTestWizardPanelVisual.class).getString("ACS_InfoPanel_XTest_Functional_CFG"));

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(12, 0, 12, 0);
        add(jSeparator1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.gridheight = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weighty = 1.0;
        add(bottomPlaceholder, gridBagConstraints);

    }
    // </editor-fold>//GEN-END:initComponents

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel bottomPlaceholder;
    private javax.swing.JLabel functionalCfgLabel;
    private javax.swing.JTextField functionalCfgTextField;
    private javax.swing.JLabel functionalScriptLabel;
    private javax.swing.JTextField functionalScriptTextField;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JLabel projectLabel;
    private javax.swing.JTextField projectTextField;
    private javax.swing.JLabel unitCfgLabel;
    private javax.swing.JTextField unitCfgTextField;
    private javax.swing.JLabel unitScriptLabel;
    private javax.swing.JTextField unitScriptTextField;
    private javax.swing.JLabel xtestScriptLabel;
    private javax.swing.JTextField xtestScriptTextField;
    // End of variables declaration//GEN-END:variables

    /** Help context where to find more about the paste type action.
     * @return the help context for this action
     */
    public HelpCtx getHelpCtx() {
        return new HelpCtx(XTestWizardPanelVisual.class);
    }    
}
